from CvPythonExtensions import *
import CvUtil
import CvEventManager #Mercenaries
import sys #Mercenaries
import PyHelpers 
import CvMainInterface #Mercenaries
import CvMercenaryManager #Mercenaries
import MercenaryUtils #Mercenaries
import CvScreenEnums  #Mercenaries
import CvConfigParser #Mercenaries
import Popup as PyPopup 

import StoredData
import RiseAndFall        
import Barbs                
import Religions        
import Resources        
import CityNameManager  
import UniquePowers     
import AIWars           
import Congresses
import Consts as con 
import RFCUtils
utils = RFCUtils.RFCUtils()
import CvScreenEnums #Mercenaries, Rhye
import Victory
import Stability
import Plague
        
gc = CyGlobalContext()        
#iBetrayalCheaters = 15

#Mercenaries - start
objMercenaryUtils = MercenaryUtils.MercenaryUtils()

PyPlayer = PyHelpers.PyPlayer
PyGame = PyHelpers.PyGame()
PyInfo = PyHelpers.PyInfo

# Set g_bGameTurnMercenaryCreation to true if mercenary creation should happen during the 
# onBeginGameTurn method, false if it should happen during the onBeginPlayerTurn method
# Default value is true
g_bGameTurnMercenaryCreation = true

# Set g_bDisplayMercenaryManagerOnBeginPlayerTurn to true if the "Mercenary Manager" 
# screen should be displayed at the beginning of every player turn. 
# Default value is false
g_bDisplayMercenaryManagerOnBeginPlayerTurn = false

# This value also controls the "Mercenary Manager" button and when it should be displayed.
# Default value is "ERA_ANCIENT"
g_iStartingEra = gc.getInfoTypeForString("ERA_ANCIENT")

# Change this to false if mercenaries should be removed from the global mercenary pool 
# at the beginning of the game turn. When set to true a number of mercenaries will 
# wander away from the global mercenary pool. This is another variable used to control 
# the load time for the "Mercenary Manager" screen.
# Default valus is true
g_bWanderlustMercenaries = true

# Change this to increase the max number of mercenaries that may wander away from the
# global mercenary pool.
# Default valus is 3
g_iWanderlustMercenariesMaximum = 6 #Rhye

# Default valus is 0 
g_iWanderlustMercenariesMinimum = 2 #Rhye

# Change this to false to supress the mercenary messages.
# Default value is true
g_bDisplayMercenaryMessages = false #Rhye

# Set to true to print out debug messages in the logs
g_bDebug = false

# Default valus is 1 
g_bUpdatePeriod = 5 #Rhye

# Default valus is 1 
g_bAIThinkPeriod = 3 #Rhye

# globals

#Mercenaries - end


###################################################
class CvRFCEventHandler:



        mercenaryManager = None #Mercenaries


        def __init__(self, eventManager):

                self.EventKeyDown=6 #Mercenaries

                # initialize base class
                eventManager.addEventHandler("GameStart", self.onGameStart) #Stability
                eventManager.addEventHandler("BeginGameTurn", self.onBeginGameTurn) #Stability
                eventManager.addEventHandler("cityAcquired", self.onCityAcquired) #Stability
                eventManager.addEventHandler("cityRazed", self.onCityRazed) #Stability
                eventManager.addEventHandler("cityBuilt", self.onCityBuilt) #Stability
                eventManager.addEventHandler("combatResult", self.onCombatResult) #Stability
                #eventManager.addEventHandler("changeWar", self.onChangeWar)
                eventManager.addEventHandler("religionFounded",self.onReligionFounded) #Victory
                eventManager.addEventHandler("buildingBuilt",self.onBuildingBuilt) #Victory
                eventManager.addEventHandler("projectBuilt",self.onProjectBuilt) #Victory
                eventManager.addEventHandler("BeginPlayerTurn", self.onBeginPlayerTurn) #Mercenaries
                eventManager.addEventHandler("EndGameTurn", self.onEndGameTurn) #Stability
                eventManager.addEventHandler("kbdEvent",self.onKbdEvent) #Mercenaries
                eventManager.addEventHandler("unitLost",self.onUnitLost) #Mercenaries
                eventManager.addEventHandler("unitKilled",self.onUnitKilled) #Mercenaries
                eventManager.addEventHandler("OnLoad",self.onLoadGame) #Mercenaries
                eventManager.addEventHandler("unitPromoted",self.onUnitPromoted) #Mercenaries
                eventManager.addEventHandler("techAcquired",self.onTechAcquired) #Mercenaries, Rhye #Stability
                eventManager.addEventHandler("improvementDestroyed",self.onImprovementDestroyed) #Stability
                eventManager.addEventHandler("religionSpread",self.onReligionSpread) #Stability
                eventManager.addEventHandler("firstContact",self.onFirstContact)


               
                self.eventManager = eventManager

                self.data = StoredData.StoredData()
                self.rnf = RiseAndFall.RiseAndFall()
                self.barb = Barbs.Barbs()
                self.rel = Religions.Religions()
                self.res = Resources.Resources()
                self.cnm = CityNameManager.CityNameManager()
                self.up = UniquePowers.UniquePowers()
                self.aiw = AIWars.AIWars()
                self.cong = Congresses.Congresses()
                self.vic = Victory.Victory()
                self.sta = Stability.Stability()
                self.pla = Plague.Plague()
                
                
                #Mercenaries - start
                
                self.mercenaryManager = CvMercenaryManager.CvMercenaryManager(CvScreenEnums.MERCENARY_MANAGER)        

                global g_bGameTurnMercenaryCreation
                global g_bDisplayMercenaryManagerOnBeginPlayerTurn
                global g_iStartingEra
                global g_bWanderlustMercenaries
                global g_iWanderlustMercenariesMaximum
                global g_bDisplayMercenaryMessages 

		#Rhye - start comment
##		# Load the Mercenaries Mod Config INI file containing all of the configuration information		
##		config = CvConfigParser.CvConfigParser("Mercenaries Mod Config.ini")
##
##		# If we actually were able to open the "Mercenaries Mod Config.ini" file then read in the values.
##		# otherwise we'll keep the default values that were set at the top of this file.
##		if(config != None):
##			g_bGameTurnMercenaryCreation = config.getboolean("Mercenaries Mod", "Game Turn Mercenary Creation", true)
##			g_bDisplayMercenaryManagerOnBeginPlayerTurn = config.getboolean("Mercenaries Mod", "Display Mercenary Manager On Begin Player Turn", false)
##			g_iStartingEra = gc.getInfoTypeForString(config.get("Mercenaries Mod","Starting Era","ERA_ANCIENT"))
##			g_bWanderlustMercenaries = config.getboolean("Mercenaries Mod", "Wanderlust Mercenaries", true)
##			g_iWanderlustMercenariesMaximum = config.getint("Mercenaries Mod","Wanderlust Mercenaries Maximum", 5)
##			g_bDisplayMercenaryMessages = config.getboolean("Mercenaries Mod", "Display Mercenary Messages", true)
		#Rhye - end comment

                objMercenaryUtils = MercenaryUtils.MercenaryUtils()
                #Mercenaries - end


        def onGameStart(self, argsList):
                'Called at the start of the game'
                self.data.setupScriptData()
                self.rnf.setup()
                self.rel.setup()
                self.pla.setup()
                self.sta.setup()

                #Mercenaries - start
                global objMercenaryUtils        
                objMercenaryUtils = MercenaryUtils.MercenaryUtils()
		#Mercenaries - end
                
                return 0


        def onCityAcquired(self, argsList):
                #'City Acquired'
                owner,playerType,city,bConquest,bTrade = argsList
                #CvUtil.pyPrint('City Acquired Event: %s' %(city.getName()))
                self.cnm.renameCities(city, playerType)
                self.up.arabianUP(city, playerType)

                self.sta.onCityAcquired(owner,playerType,city,bConquest,bTrade)
                
                if (bConquest):
                        #self.rnf.collapseCapitals(owner, city, playerType)
                        if (owner == utils.getHumanID() and playerType != con.iBarbarian):
                                self.rnf.collapseHuman(owner, city, playerType)
                        #print ("exile data:", self.rnf.getExileData(0), city.getX(), self.rnf.getExileData(1), city.getY(), self.rnf.getExileData(2))
                        if (self.rnf.getExileData(0) == city.getX() and self.rnf.getExileData(1) == city.getY()):
                                if (playerType == utils.getHumanID() and self.rnf.getExileData(2) != -1):
                                        self.rnf.escape(city)
                if (bTrade):
                        for i in range (con.iScotlandYard +1 - con.iHeroicEpic):
                                iNationalWonder = i + con.iHeroicEpic
                                if (city.hasBuilding(iNationalWonder)):
                                        city.setHasRealBuilding((iNationalWonder), False)

                self.pla.onCityAcquired(owner,playerType,city) #Plague

                self.vic.onCityAcquired(owner, playerType, bConquest) #Victory
                
                return 0

        def onCityRazed(self, argsList):
                #'City Razed'
                city, iPlayer = argsList

                self.sta.onCityRazed(city.getOwner(),iPlayer,city)
		
                if (iPlayer == con.iMongolia):
                        self.up.setLatestRazeData(0, gc.getGame().getGameTurn())
                        owner = city.getOwner()
                        if (city.getOwner() == iPlayer):
                                if (city.getPreviousOwner() != -1):
                                        owner = city.getPreviousOwner()                        
                        self.up.setLatestRazeData(1, owner)
                        self.up.setLatestRazeData(2, city.getPopulation())
                        self.up.setLatestRazeData(3, city.getX())
                        self.up.setLatestRazeData(4, city.getY())
                        print ("city.getPopulation()", city.getPopulation())
                        print ("prev", city.getPreviousOwner(), "curr", city.getOwner())
                        self.up.setMongolAI()

                self.pla.onCityRazed(city,iPlayer) #Plague
                        
                if (iPlayer == con.iMongolia):
                        self.vic.onCityRazed(iPlayer) #Victory



        def onCityBuilt(self, argsList):
                'City Built'
                city = argsList[0]
                
                
                if (city.getOwner() < con.iNumActivePlayers): 
                        self.cnm.assignName(city)


                #Rhye - delete culture of barbs and minor civs to prevent weird unhappiness
                pCurrent = gc.getMap().plot( city.getX(), city.getY() )
                for i in range(con.iNumTotalPlayers - con.iNumActivePlayers):
                        iMinorCiv = i + con.iNumActivePlayers
                        pCurrent.setCulture(iMinorCiv, 0, True)
                pCurrent.setCulture(con.iBarbarian, 0, True)

                if (city.getOwner() == con.iRussia or \
                    city.getOwner() == con.iFrance or \
                    city.getOwner() == con.iEngland or \
                    city.getOwner() == con.iSpain or \
                    #city.getOwner() == con.iCarthage or \
                    city.getOwner() == con.iVikings):    
                        self.vic.onCityBuilt(city, city.getOwner()) #Victory

                if (city.getOwner() < con.iNumPlayers):
                        self.sta.onCityBuilt(city.getOwner(), city.getX(), city.getY() )

        def onCombatResult(self, argsList):
                self.up.aztecUP(argsList)
                self.vic.onCombatResult(argsList)
                self.sta.onCombatResult(argsList)



##        def onChangeWar(self, argsList):
##                print ("No cheaters1")
##                if (bIsWar):
##                        print ("No cheaters2")
##                        if (argsList[1] == utils.getHumanID() and gc.getGame().getGameTurn() <= con.tBirth[argsList[1]] + iBetrayalCheaters):
##                                print ("No cheaters3")
##                                self.rnf.setNewCivFlip(argsList[1])
##                                self.rnf.setTempTopLeft(rnf.tCoreAreasTL[argsList[1]])
##                                self.rnf.setTempBottomRight(rnf.tCoreAreasBR[argsList[1]])
##                                self.rnf.setBetrayalTurns(rnf.iBetrayalPeriod)
##                                self.rnf.initBetrayal()



        def onReligionFounded(self, argsList):
                'Religion Founded'
                iReligion, iFounder = argsList
        
                self.vic.onReligionFounded(iReligion, iFounder)
        
                if (iFounder < con.iNumPlayers):
                        self.sta.onReligionFounded(iFounder)


        def onBuildingBuilt(self, argsList):
                city, iBuildingType = argsList
                self.vic.onBuildingBuilt(city.getOwner(), iBuildingType)
                if (city.getOwner() < con.iNumPlayers):
                        self.sta.onBuildingBuilt(city.getOwner(), iBuildingType, city)

        def onProjectBuilt(self, argsList):
                city, iProjectType = argsList
                self.vic.onProjectBuilt(city.getOwner(), iProjectType)
                if (city.getOwner() < con.iNumPlayers):
                        self.sta.onProjectBuilt(city.getOwner(), iProjectType)

        def onImprovementDestroyed(self, argsList):
                pass
                #iImprovement, iOwner, iX, iY = argsList
                #if (iOwner < con.iNumPlayers):
                #        self.sta.onImprovementDestroyed(iOwner)           
                
        def onBeginGameTurn(self, argsList):
                iGameTurn = argsList[0]

                print ("iGameTurn", iGameTurn)
                #debug
                #self.data.setupScriptData()
                #if (len(lLeaders[iDeadCiv]) > 1):
                #gc.getTeam(gc.getPlayer(con.iInca).getTeam()).cutContact(con.iEngland)
                #for i in range (con.iNumPlayers):
                #        gc.getTeam(gc.getPlayer(con.iInca).getTeam()).cutContact(i)
                #gc.getTeam(gc.getPlayer(con.iCarthage).getTeam()).setVassal(con.iSpain, False, False)
                #gc.getGame().changePlayer(con.iChina, 0, 22, con.iChina, False, True)
                #gc.getPlayer(con.iBabylonia).setLeader(24)
##                #if (iGameTurn > 0): 
##                if (iGameTurn %5 == 0):   
##                        #countTotalUnits
##                        iTotal = 0
##                        iTotalCities = 0
##                        lType = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                                 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                                 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                                 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                                 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                                 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                                 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                                 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                                 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                                 0, 0, 0]
##                        lOwner = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                                 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                                 0, 0, 0, 0, 0, 0, 0]
##                        #lOwnerLongbow = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                        #         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                        #         0, 0, 0, 0, 0, 0, 0]
##                        #lOwnerCannon = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                        #         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
##                        #         0, 0, 0, 0, 0, 0, 0] 
##                        for x in range(0, 123):
##                                for y in range(0, 67):
##                                        pCurrent = gc.getMap().plot( x, y )
##                                        iTotal += pCurrent.getNumUnits()
##                                        if (pCurrent.getNumUnits() > 0):
##                                                for i in range (pCurrent.getNumUnits()):
##                                                        unit = pCurrent.getUnit(i)
##                                                        #lType[unit.getUnitType()] += 1
##                                                        lOwner[unit.getOwner()] += 1
##                                                        #if (unit.getUnitType() == con.iLongbowman):
##                                                        #       lOwnerLongbow[unit.getOwner()] += 1
##                                                        #if (unit.getUnitType() == con.iCannon):
##                                                        #       lOwnerCannon[unit.getOwner()] += 1
##
##                                        if ( pCurrent.isCity()):
##                                                iTotalCities += 1   
##                        print ("TOTAL UNITS", iTotal)  
##                        print ("TOTAL CITIES", iTotalCities)
##                                
##                        print ("Unit types")
##                        for i in range (len(lType)):
##                                print (i, lType[i])
##                        print ("Unit owners")
##                        for i in range (len(lOwner)):
##                                print (i, lOwner[i])
##                        print ("LB owners")
##                        for j in range (len(lOwnerLongbow)):
##                                print (j, lOwnerLongbow[j])               
##                        print ("Cannon owners")
##                        for j in range (len(lOwnerCannon)):
##                                print (j, lOwnerCannon[j])               
            
     

##                #debug - kills every unit
##                for x in range(40, 123):
##                        for y in range(0, 67):
##                                pCurrent = gc.getMap().plot( x, y )
##                                if (pCurrent.getNumUnits() > 0):
##                                        for i in range (pCurrent.getNumUnits()):
##                                                unit = pCurrent.getUnit(0)
##                                                unit.kill(False, con.iBarbarian)

                
                
                self.rnf.checkTurn(iGameTurn)
                self.barb.checkTurn(iGameTurn)
                self.rel.checkTurn(iGameTurn)
                self.res.checkTurn(iGameTurn)
                self.up.checkTurn(iGameTurn)
                self.aiw.checkTurn(iGameTurn)
                self.cong.checkTurn(iGameTurn)
                self.pla.checkTurn(iGameTurn)
                self.vic.checkTurn(iGameTurn)
                self.sta.checkTurn(iGameTurn)

                #Mercenaries - start

                if ((not gc.getTeam(gc.getActivePlayer().getTeam()).isHasTech(con.iNationalism)) and gc.getGame().getGameTurn() >= con.tBirth[utils.getHumanID()]):
                        
                        # Get the list of active players in the game
                        playerList = PyGame.getCivPlayerList()
                        
                        # Go through each of the players and deduct their mercenary maintenance amount from their gold
                        for i in range(len(playerList)):
                                playerList[i].setGold(playerList[i].getGold()-objMercenaryUtils.getPlayerMercenaryMaintenanceCost(playerList[i].getID()))
                                playerList[i].setGold(playerList[i].getGold()+objMercenaryUtils.getPlayerMercenaryContractIncome(playerList[i].getID()))
                
                        # Have some mercenaries wander away from the global mercenary pool if 
                        # g_bWanderlustMercenaries is set to true.        
                        if(g_bWanderlustMercenaries):

                                #Rhye - start (less frequent updates)
                                #wanderingMercenaryCount = gc.getGame().getMapRand().get(g_iWanderlustMercenariesMaximum, "Random Num")
                                #objMercenaryUtils.removeMercenariesFromPool(wanderingMercenaryCount)
                                teamPlayer = gc.getTeam(gc.getActivePlayer().getTeam())
                                if (not teamPlayer.isHasTech(con.iNationalism)):                     
                                        if (iGameTurn % g_bUpdatePeriod == (g_bUpdatePeriod-1)):
                                                wanderingMercenaryCount = gc.getGame().getMapRand().get(g_iWanderlustMercenariesMaximum, "Random Num") + g_iWanderlustMercenariesMinimum
                                                objMercenaryUtils.removeMercenariesFromPool(wanderingMercenaryCount)
                                #Rhye - end
                            
                                
                        # Add the mercenaries to the global mercenary pool if the g_bGameTurnMercenaryCreation 
                        # is set to true
                        if(g_bGameTurnMercenaryCreation):
                            
                                #Rhye - start (less frequent updates)
                                #objMercenaryUtils.addMercenariesToPool()                  
                                if (iGameTurn % g_bUpdatePeriod == (g_bUpdatePeriod-1)):
                                        objMercenaryUtils.addMercenariesToPool()
                                #Rhye - end                
                return 0



        def onBeginPlayerTurn(self, argsList):        
                iGameTurn, iPlayer = argsList

                #print ("PLAYER", iPlayer)
                #if (iPlayer == con.iMongolia):
                #        if (iGameTurn == self.up.getLatestRazeData(0) +1):
                #                self.up.setMongolAI()


                if (self.rnf.getDeleteMode() != -1):
                        self.rnf.deleteMode(iPlayer)
                        
                self.pla.checkPlayerTurn(iGameTurn, iPlayer)

                if (gc.getPlayer(iPlayer).isAlive()):
                        self.vic.checkPlayerTurn(iGameTurn, iPlayer)


                if (gc.getPlayer(iPlayer).isAlive() and iPlayer < con.iNumPlayers and gc.getPlayer(iPlayer).getNumCities() > 0):
                        self.sta.updateBaseStability(iGameTurn, iPlayer)

                if (gc.getPlayer(iPlayer).isAlive() and iPlayer < con.iNumPlayers and not gc.getPlayer(iPlayer).isHuman()):
                        self.rnf.checkPlayerTurn(iGameTurn, iPlayer) #for leaders switch

                #Mercenaries - start
        
                # This method will add mercenaries to the global mercenary pool, display the mercenary manager screen
                # and provide the logic to make the computer players think.
                player = gc.getPlayer(iPlayer)

                if ((not gc.getTeam(gc.getActivePlayer().getTeam()).isHasTech(con.iNationalism)) and gc.getGame().getGameTurn() >= con.tBirth[utils.getHumanID()]): #Rhye

                        # Debug code - start
                        if(g_bDebug):
                                CvUtil.pyPrint(player.getName() + " Gold: " + str(player.getGold()) + " is human: " + str(player.isHuman()))
                        # Debug code - end        
                        
                        # Add the mercenaries to the global mercenary pool if the 
                        # g_bGameTurnMercenaryCreation is set to false
                        if(not g_bGameTurnMercenaryCreation):
                                objMercenaryUtils.addMercenariesToPool()

                        # if g_bDisplayMercenaryManagerOnBeginPlayerTurn is true the the player is human
                        # then display the mercenary manager screen
                        if(g_bDisplayMercenaryManagerOnBeginPlayerTurn and player.isHuman()):
                                self.mercenaryManager.interfaceScreen()

                        # if the player is not human then run the think method
                        if(not player.isHuman()):
                            
                                #Rhye - start
                                #objMercenaryUtils.computerPlayerThink(iPlayer)                                        
                                if (player.isAlive()):
                                        if (iPlayer % (g_bAIThinkPeriod) == iGameTurn % (g_bAIThinkPeriod) and not gc.getTeam(player.getTeam()).isHasTech(con.iNationalism)):
                                                print ("AI thinking (Mercenaries)", iPlayer) #Rhye
                                                objMercenaryUtils.computerPlayerThink(iPlayer)                                                                
                                #Rhye - end
                
                        # Place any mercenaries that might be ready to be placed.
                        objMercenaryUtils.placeMercenaries(iPlayer)
        
        
        def onEndPlayerTurn(self, argsList):
                'Called at the end of a players turn'

                if ((not gc.getTeam(gc.getActivePlayer().getTeam()).isHasTech(con.iNationalism)) and gc.getGame().getGameTurn() >= con.tBirth[utils.getHumanID()]): #Rhye
                
                        iGameTurn, iPlayer = argsList
                        
                        player = gc.getPlayer(iPlayer)

                        CyInterface().addImmediateMessage(player.getName(),"")



        def onEndGameTurn(self, argsList):
            
                iGameTurn = argsList[0]
                self.sta.checkImplosion(iGameTurn)


        def onReligionSpread(self, argsList):
            
                iReligion, iOwner, pSpreadCity = argsList
                self.sta.onReligionSpread(iReligion, iOwner)             

        def onFirstContact(self, argsList):
            
                iTeamX,iHasMetTeamY = argsList
                self.pla.onFirstContact(iTeamX, iHasMetTeamY)

        #Rhye - start
        def onTechAcquired(self, argsList):

                #print ("onTechAcquired", argsList)
                iPlayer = argsList[2]
                
                if (gc.getGame().getGameTurn() > con.tBirth[iPlayer]):                    
                        if (iPlayer == con.iGreece or \
                            iPlayer == con.iEngland or \
                            iPlayer == con.iGermany or \
                            iPlayer == con.iAztecs or \
                            iPlayer == con.iBabylonia):                            
                                self.vic.onTechAcquired(argsList[0], argsList[2])
                                
                
                if (gc.getPlayer(iPlayer).isAlive() and gc.getGame().getGameTurn() > con.tBirth[iPlayer] and iPlayer < con.iNumPlayers):
                        self.sta.onTechAcquired(argsList[0], argsList[2])                       



                if (gc.getGame().getGameTurn() >= con.tBirth[utils.getHumanID()]):

                        if (argsList[0] == con.iNationalism):
                                if (argsList[2] == utils.getHumanID()):
                                        for iLoopCiv in range (con.iNumPlayers):
                                    
                                                mercenaryDict = objMercenaryUtils.getPlayerMercenaries(iLoopCiv)
                                                mercenary = objMercenaryUtils.getHighestMaintenanceMercenary(mercenaryDict)

                                                while(mercenary != None):
                                                        print ("tech3")
                                                        # Get the mercenary with the highest maintenance cost
                                                        mercenaryDict = objMercenaryUtils.getPlayerMercenaries(iLoopCiv)
                                                        mercenary = objMercenaryUtils.getHighestMaintenanceMercenary(mercenaryDict)
                                                        # Have the computer fire the mercenary
                                                        if(mercenary != None):
                                                                objMercenaryUtils.fireMercenary(mercenary.getName(), iLoopCiv)
                                        screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
                                        screen.hide("MercenaryManagerButton")
                                        CyInterface().addImmediateMessage( CyTranslator().getText("TXT_KEY_MERCENARIES_DISABLED", ()), "")
                                
        #Rhye - end
                
                
        # This method handles the key input and will bring up the mercenary manager screen if the 
        # player has at least one city and presses the 'M' key.
        def onKbdEvent(self, argsList):
                'keypress handler - return 1 if the event was consumed'

                if ((not gc.getTeam(gc.getActivePlayer().getTeam()).isHasTech(con.iNationalism)) and gc.getGame().getGameTurn() >= con.tBirth[utils.getHumanID()]): #Rhye
                
                        # TO DO: REMOVE THE FOLLOWING LINE BEFORE RELEASE.
                        #gc.getPlayer(0).setGold(20000)
                        eventType,key,mx,my,px,py = argsList
                                
                        theKey=int(key)

                        if ( eventType == self.EventKeyDown and theKey == int(InputTypes.KB_M) and self.eventManager.bAlt and gc.getActivePlayer().getNumCities() > 0 and gc.getActivePlayer().getCurrentEra() >= g_iStartingEra):

                                self.mercenaryManager.interfaceScreen()

                                

        # This method creates a new instance of the MercenaryUtils class to be used later
        def onLoadGame(self, argsList):

                if ((not gc.getTeam(gc.getActivePlayer().getTeam()).isHasTech(con.iNationalism)) and gc.getGame().getGameTurn() >= con.tBirth[utils.getHumanID()]): #Rhye

                        global objMercenaryUtils

                        objMercenaryUtils = MercenaryUtils.MercenaryUtils()



        # This method will redraw the main interface once a unit is promoted. This way the 
        # gold/turn information will be updated.        
        def onUnitPromoted(self, argsList):
                'Unit Promoted'

                if ((not gc.getTeam(gc.getActivePlayer().getTeam()).isHasTech(con.iNationalism)) and gc.getGame().getGameTurn() >= con.tBirth[utils.getHumanID()]): #Rhye        
                        pUnit, iPromotion = argsList
                        player = PyPlayer(pUnit.getOwner())

                        if(objMercenaryUtils.isMercenary(pUnit)):
                                CyInterface().setDirty(InterfaceDirtyBits.GameData_DIRTY_BIT, True)




        # This method will remove a mercenary unit from the game if it is killed
        def onUnitKilled(self, argsList):
                'Unit Killed'

                if ((not gc.getTeam(gc.getActivePlayer().getTeam()).isHasTech(con.iNationalism)) and gc.getGame().getGameTurn() >= con.tBirth[utils.getHumanID()]): #Rhye
                    
                        unit, iAttacker = argsList
                        
                        mercenary = objMercenaryUtils.getMercenary(unit.getNameNoDesc())

                        if(mercenary != None and g_bDisplayMercenaryMessages and mercenary.getBuilder() != -1 and unit.isDead()):
                                strMessage = mercenary.getName() + " has died under " + gc.getPlayer(mercenary.getOwner()).getName() + "'s service."
                                # Inform the player that the mercenary has died.
                                CyInterface().addMessage(mercenary.getBuilder(), True, 20, strMessage, "", 0, "", ColorTypes(0), -1, -1, True, True) 

                        objMercenaryUtils.removePlayerMercenary(unit)


        # This method will remove a mercenary unit from the game if it is lost
        def onUnitLost(self, argsList):
                'Unit Lost'

                if ((not gc.getTeam(gc.getActivePlayer().getTeam()).isHasTech(con.iNationalism)) and gc.getGame().getGameTurn() >= con.tBirth[utils.getHumanID()]): #Rhye
        
                        unit = argsList[0]
                        
                        # Debug code - start
                        if(g_bDebug):
                                CvUtil.pyPrint("lost: " + unit.getName())
                        # Debug code - end
                        
                        # If the unit being lost is a mercenary, check to see if they have been
                        # replaced by an upgraded version of themselves. If they are then save
                        # the new upgraded version of themselves and return immediately.
                        if(objMercenaryUtils.isMercenary(unit)):

                                # Debug code - start
                                if(g_bDebug):        
                                        CvUtil.pyPrint("mercenary unit lost: " + unit.getName())
                                # Debug code - end
                                        
                                # Get the active player ID
                                iPlayer = gc.getGame().getActivePlayer()
                                
                                # Get the reference of the actual player
                                pyPlayer = PyPlayer(iPlayer)

                                # Get the list of units for the player
                                unitList = pyPlayer.getUnitList()
                                        
                                # Go through the list of units to see if an upgraded version of 
                                # the unit has been added. If it exists then save it and return
                                # immediately.
                                for unit in unitList:

                                        if(unit.getUnitType() != argsList[0].getUnitType() and unit.getNameNoDesc() == argsList[0].getNameNoDesc()):

                                                # Debug code - start
                                                if(g_bDebug):        
                                                        CvUtil.pyPrint("mercenary unit upgraded: " + unit.getName())
                                                # Debug code - end
                                                
                                                tmpMerc = objMercenaryUtils.createBlankMercenary()
                                                tmpMerc.loadUnitData(unit)
                                                tmpMerc.iBuilder = -1
                                                objMercenaryUtils.saveMercenary(tmpMerc)
                                                return
                                                
                        mercenary = objMercenaryUtils.getMercenary(unit.getNameNoDesc())

                        if(mercenary != None and g_bDisplayMercenaryMessages and mercenary.getBuilder() != -1 and unit.isDead()):
                                strMessage = mercenary.getName() + " was lost under " + gc.getPlayer(mercenary.getOwner()).getName() + "'s service."
                                # Inform the player that the mercenary has died.
                                CyInterface().addMessage(mercenary.getBuilder(), True, 20, strMessage, "", 0, "", ColorTypes(0), -1, -1, True, True) 
                        unit = argsList[0]
                        
                        # Debug code - start
                        if(g_bDebug):        
                                CvUtil.pyPrint("lost??: " + unit.getNameNoDesc())        
                        # Debug code - end

                        objMercenaryUtils.removePlayerMercenary(unit)
        
        #Mercenaries - end

                
