# Rhye's and Fall of Civilization - Main Scenario

from CvPythonExtensions import *
import CvUtil
import PyHelpers        # LOQ
import Popup
import pickle        	# LOQ 2005-10-12
import CvTranslator
import RFCUtils
import Consts as con




################
### Globals ###
##############

gc = CyGlobalContext()	# LOQ
PyPlayer = PyHelpers.PyPlayer	# LOQ
utils = RFCUtils.RFCUtils()

iCheatersPeriod = 12
iBetrayalPeriod = 8
iBetrayalThreshold = 66
iRebellionDelay = 15
iEscapePeriod = 30
tAIStopBirthThreshold = con.tAIStopBirthThreshold
tBirth = con.tBirth

iSettler = con.iSettler
iWarrior = con.iWarrior
iScout = con.iScout
iGalley = con.iGalley


# initialise player variables

iEgypt = con.iEgypt
iIndia = con.iIndia
iChina = con.iChina
iBabylonia = con.iBabylonia
iGreece = con.iGreece
iPersia = con.iPersia
iCarthage = con.iCarthage
iRome = con.iRome
iJapan = con.iJapan
iVikings = con.iVikings
iArabia = con.iArabia
iSpain = con.iSpain
iFrance = con.iFrance
iEngland = con.iEngland
iGermany = con.iGermany
iRussia = con.iRussia
iMali = con.iMali
iTurkey = con.iTurkey
iInca = con.iInca
iMongolia = con.iMongolia
iAztecs = con.iAztecs
iAmerica = con.iAmerica
iNumPlayers = con.iNumPlayers
iNumMajorPlayers = con.iNumMajorPlayers
#iHolland = con.iHolland
#iPortugal = con.iPortugal
iNumActivePlayers = con.iNumActivePlayers
iIndependent = con.iIndependent
iIndependent2 = con.iIndependent2
iNative = con.iNative
iCeltia = con.iCeltia
iBarbarian = con.iBarbarian
iNumTotalPlayers = con.iNumTotalPlayers


pEgypt = gc.getPlayer(iEgypt)
pIndia = gc.getPlayer(iIndia)
pChina = gc.getPlayer(iChina)
pBabylonia = gc.getPlayer(iBabylonia)
pGreece = gc.getPlayer(iGreece)
pPersia = gc.getPlayer(iPersia)
pCarthage = gc.getPlayer(iCarthage)
pRome = gc.getPlayer(iRome)
pJapan = gc.getPlayer(iJapan)
pVikings = gc.getPlayer(iVikings)
pArabia = gc.getPlayer(iArabia)
pSpain = gc.getPlayer(iSpain)
pFrance = gc.getPlayer(iFrance)
pEngland = gc.getPlayer(iEngland)
pGermany = gc.getPlayer(iGermany)
pRussia = gc.getPlayer(iRussia)
pMali = gc.getPlayer(iMali)
pTurkey = gc.getPlayer(iTurkey)
pInca = gc.getPlayer(iInca)
pMongolia = gc.getPlayer(iMongolia)
pAztecs = gc.getPlayer(iAztecs)
pAmerica = gc.getPlayer(iAmerica)
#pHolland = gc.getPlayer(iHolland)
#pPortugal = gc.getPlayer(iPortugal)
pIndependent = gc.getPlayer(iIndependent)
pIndependent2 = gc.getPlayer(iIndependent2)
pNative = gc.getPlayer(iNative)
pCeltia = gc.getPlayer(iCeltia)
pBarbarian = gc.getPlayer(iBarbarian)

teamEgypt = gc.getTeam(pEgypt.getTeam())
teamIndia = gc.getTeam(pIndia.getTeam())
teamChina = gc.getTeam(pChina.getTeam())
teamBabylonia = gc.getTeam(pBabylonia.getTeam())
teamGreece = gc.getTeam(pGreece.getTeam())
teamPersia = gc.getTeam(pPersia.getTeam())
teamCarthage = gc.getTeam(pCarthage.getTeam())
teamRome = gc.getTeam(pRome.getTeam())
teamJapan = gc.getTeam(pJapan.getTeam())
teamVikings = gc.getTeam(pVikings.getTeam())
teamArabia = gc.getTeam(pArabia.getTeam())
teamSpain = gc.getTeam(pSpain.getTeam())
teamFrance = gc.getTeam(pFrance.getTeam())
teamEngland = gc.getTeam(pEngland.getTeam())
teamGermany = gc.getTeam(pGermany.getTeam())
teamRussia = gc.getTeam(pRussia.getTeam())
teamMali = gc.getTeam(pMali.getTeam())
teamTurkey = gc.getTeam(pTurkey.getTeam())
teamInca = gc.getTeam(pInca.getTeam())
teamMongolia = gc.getTeam(pMongolia.getTeam())
teamAztecs = gc.getTeam(pAztecs.getTeam())
teamAmerica = gc.getTeam(pAmerica.getTeam())
#teamHolland = gc.getTeam(pHolland.getTeam())
#teamPortugal = gc.getTeam(pPortugal.getTeam())
teamIndependent = gc.getTeam(pIndependent.getTeam())
teamIndependent2 = gc.getTeam(pIndependent2.getTeam())
teamNative = gc.getTeam(pNative.getTeam())
teamCeltia = gc.getTeam(pCeltia.getTeam())
teamBarbarian = gc.getTeam(pBarbarian.getTeam())


#for not allowing new civ popup if too close
tDifference = (0, 0, 0, 0, 3, 2, 2, 1, 0, 6, 5, 4, 3, 2, 1, 1, 1, 2, 2, 1, 0, 0)
#debug tDifference = (0, 0, 0, 0, 3, 2, 2, 1, 0, 6, 5, 4, 3, 2, 1, 1, 1, 4, 3, 3, 3, 3)
#debug tDifference = (0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 5, 4, 3, 2, 1, 1, 1, 2, 2, 1, 0, 0)
                    


# starting locations coordinates
tCapitals = con.tCapitals



# core areas coordinates (top left and bottom right)

tCoreAreasTL = con.tCoreAreasTL
tCoreAreasBR = con.tCoreAreasBR

tExceptions = con.tExceptions

tNormalAreasTL = con.tNormalAreasTL
tNormalAreasBR = con.tNormalAreasBR

tBroaderAreasTL = con.tBroaderAreasTL 
tBroaderAreasBR = con.tBroaderAreasBR

tLeaders = con.tLeaders
tEarlyLeaders = con.tEarlyLeaders
tLateLeaders = con.tLateLeaders

class RiseAndFall:


##################################################
### Secure storage & retrieval of script data ###
################################################
        

        def getNewCiv( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iNewCiv']

        def setNewCiv( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iNewCiv'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )        

        def getNewCivFlip( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iNewCivFlip']

        def setNewCivFlip( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iNewCivFlip'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )      
        
        def getTempTopLeft( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['tempTopLeft']

        def setTempTopLeft( self, tNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['tempTopLeft'] = tNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) ) 

        def getTempBottomRight( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['tempBottomRight']

        def setTempBottomRight( self, tNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['tempBottomRight'] = tNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) ) 

        def getSpawnWar( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iSpawnWar']

        def setSpawnWar( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iSpawnWar'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getAlreadySwitched( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['bAlreadySwitched']

        def setAlreadySwitched( self, bNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['bAlreadySwitched'] = bNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getColonistsAlreadyGiven( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lColonistsAlreadyGiven'][iCiv]

        def setColonistsAlreadyGiven( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lColonistsAlreadyGiven'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getNumCities( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lNumCities'][iCiv]

        def setNumCities( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lNumCities'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getSpawnDelay( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lSpawnDelay'][iCiv]

        def setSpawnDelay( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lSpawnDelay'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getFlipsDelay( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lFlipsDelay'][iCiv]

        def setFlipsDelay( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lFlipsDelay'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getBetrayalTurns( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iBetrayalTurns']

        def setBetrayalTurns( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iBetrayalTurns'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )  

        def getLatestFlipTurn( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iLatestFlipTurn']

        def setLatestFlipTurn( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iLatestFlipTurn'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getLatestRebellionTurn( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lLatestRebellionTurn'][iCiv]

        def setLatestRebellionTurn( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lLatestRebellionTurn'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getRebelCiv( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iRebelCiv']

        def setRebelCiv( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iRebelCiv'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )
                
        def getExileData( self, i ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lExileData'][i]

        def setExileData( self, i, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lExileData'][i] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )
        
        def getTempFlippingCity( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['tempFlippingCity']

        def setTempFlippingCity( self, tNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['tempFlippingCity'] = tNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) ) 

        def getCheatersCheck( self, i ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lCheatersCheck'][i]

        def setCheatersCheck( self, i, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lCheatersCheck'][i] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getBirthTurnModifier( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lBirthTurnModifier'][iCiv]

        def setBirthTurnModifier( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lBirthTurnModifier'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )   

        def getDeleteMode( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iDeleteMode']

        def setDeleteMode( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iDeleteMode'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) ) 
                
###############
### Popups ###
#############

        ''' popupID has to be a registered ID in CvRhyesCatapultEventManager.__init__!! '''
        def showPopup(self, popupID, title, message, labels):
                popup = Popup.PyPopup(popupID, EventContextTypes.EVENTCONTEXT_ALL)
                popup.setHeaderString(title)
                popup.setBodyString(message)
                for i in labels:
                    popup.addButton( i )
                popup.launch(False)


        def newCivPopup(self, iCiv):
                self.showPopup(7614, CyTranslator().getText("TXT_KEY_NEWCIV_TITLE", ()), CyTranslator().getText("TXT_KEY_NEWCIV_MESSAGE1", ()) + " " + gc.getPlayer(iCiv).getCivilizationAdjective(0) + " " + CyTranslator().getText("TXT_KEY_NEWCIV_MESSAGE2", ()), (CyTranslator().getText("TXT_KEY_POPUP_YES", ()), CyTranslator().getText("TXT_KEY_POPUP_NO", ())))
                self.setNewCiv(iCiv)

        def eventApply7614(self, popupReturn):
                if( popupReturn.getButtonClicked() == 0 ): # 1st button
                        gc.getGame().setActivePlayer(self.getNewCiv(), False)
                        for i in range(con.iNumStabilityParameters):
                                utils.setStabilityParameters(i, 0)
                        self.setAlreadySwitched(True)
                        #CyInterface().addImmediateMessage("first button", "")
                #elif( popupReturn.getButtonClicked() == 1 ): # 2nd button
                        #CyInterface().addImmediateMessage("second button", "")


        def flipPopup(self, iNewCiv, tTopLeft, tBottomRight):
                iHuman = utils.getHumanID()
                flipText = CyTranslator().getText("TXT_KEY_FLIPMESSAGE1", ())
                for x in range(tTopLeft[0], tBottomRight[0]+1):
                        for y in range(tTopLeft[1], tBottomRight[1]+1):
                                pCurrent = gc.getMap().plot( x, y )
                                if ( pCurrent.isCity()):
                                        if (pCurrent.getPlotCity().getOwner() == iHuman):
                                                if (not pCurrent.getPlotCity().isCapital()):
                                                        flipText += (pCurrent.getPlotCity().getName() + "\n")
                #exceptions
                if (len(tExceptions[iNewCiv])):
                        for j in range(len(tExceptions[iNewCiv])):
                                pCurrent = gc.getMap().plot( tExceptions[iNewCiv][j][0], tExceptions[iNewCiv][j][1] )
                                if (pCurrent.isCity()):
                                        if (pCurrent.getPlotCity().getOwner() == iHuman):
                                                if (not pCurrent.getPlotCity().isCapital()):
                                                        flipText += (pCurrent.getPlotCity().getName() + "\n")                                                
                flipText += CyTranslator().getText("TXT_KEY_FLIPMESSAGE2", ())
                                                        
                self.showPopup(7615, CyTranslator().getText("TXT_KEY_NEWCIV_TITLE", ()), flipText, (CyTranslator().getText("TXT_KEY_POPUP_YES", ()), CyTranslator().getText("TXT_KEY_POPUP_NO", ())))
                self.setNewCivFlip(iNewCiv)
                self.setTempTopLeft(tTopLeft)
                self.setTempBottomRight(tBottomRight)

        def eventApply7615(self, popupReturn):
                iHuman = utils.getHumanID()
                tTopLeft = self.getTempTopLeft()
                tBottomRight = self.getTempBottomRight()

                humanCityList = []
                for x in range(tTopLeft[0], tBottomRight[0]+1):
                        for y in range(tTopLeft[1], tBottomRight[1]+1):
                                pCurrent = gc.getMap().plot( x, y )
                                if ( pCurrent.isCity()):
                                        city = pCurrent.getPlotCity()
                                        if (city.getOwner() == iHuman):
                                                if (not city.isCapital()):
                                                        humanCityList.append(city)
                #exceptions
                if (len(tExceptions[self.getNewCivFlip()])):
                        for j in range(len(tExceptions[self.getNewCivFlip()])):
                                pCurrent = gc.getMap().plot( tExceptions[self.getNewCivFlip()][j][0], tExceptions[self.getNewCivFlip()][j][1] )
                                if (pCurrent.isCity()):
                                        city = pCurrent.getPlotCity()
                                        if (city.getOwner() == iHuman):
                                                if (not city.isCapital()):
                                                        humanCityList.append(city)
                
                if( popupReturn.getButtonClicked() == 0 ): # 1st button
                        print ("Flip agreed")
                        CyInterface().addImmediateMessage(CyTranslator().getText("TXT_KEY_FLIP_AGREED", ()), "")
                                                
                        if (len(humanCityList)):
                                for i in range(len(humanCityList)):
                                        city = humanCityList[i]
                                        print ("flipping ", city.getName())
                                        utils.cultureManager((city.getX(),city.getY()), 100, self.getNewCivFlip(), iHuman, False, False, False)
                                        utils.flipUnitsInCityBefore((city.getX(),city.getY()), self.getNewCivFlip(), iHuman)
                                        self.setTempFlippingCity((city.getX(),city.getY()))
                                        utils.flipCity((city.getX(), city.getY()), 0, 0, self.getNewCivFlip(), [iHuman])                                        
                                        utils.flipUnitsInCityAfter(self.getTempFlippingCity(), self.getNewCivFlip())

                        #same code as Betrayal - done just once to make sure human player doesn't hold a stack just outside of the cities
                        for x in range(tTopLeft[0], tBottomRight[0]+1):
                                for y in range(tTopLeft[1], tBottomRight[1]+1):
                                        betrayalPlot = gc.getMap().plot(x,y)
                                        iNumUnitsInAPlot = killPlot.getNumUnits()
                                        if (iNumUnitsInAPlot):                                                                  
                                                for i in range(iNumUnitsInAPlot):                                                
                                                        unit = betrayalPlot.getUnit(i)
                                                        if (unit.getOwner() == iHuman):
                                                                rndNum = gc.getGame().getSorenRandNum(100, 'betrayal')
                                                                if (rndNum >= iBetrayalThreshold):
                                                                        if (unit.getDomainType() == 2): #land unit
                                                                                unit.kill(False, iNewOwner)
                                                                                utils.makeUnit(unit.getUnitType(), self.getNewCivFlip(), betrayalPlot, 1)
                                                                                i = i - 1


                        if (self.getCheatersCheck(0) == 0):
                                self.setCheatersCheck(0, iCheatersPeriod)
                                self.setCheatersCheck(1, self.getNewCivFlip())
                                
                elif( popupReturn.getButtonClicked() == 1 ): # 2nd button
                        print ("Flip disagreed")

                        if (len(humanCityList)):
                                for i in range(len(humanCityList)):
                                        city = humanCityList[i]
                                        #city.setCulture(self.getNewCivFlip(), city.countTotalCulture(), True)
                                        pCurrent = gc.getMap().plot(city.getX(), city.getY())
                                        oldCulture = pCurrent.getCulture(iHuman)
                                        pCurrent.setCulture(self.getNewCivFlip(), oldCulture/2, True)
                                        pCurrent.setCulture(iHuman, oldCulture/2, True)                                        
                                        iWar = self.getSpawnWar() + 1
                                        self.setSpawnWar(iWar)
                                        if (self.getSpawnWar() == 1):
                                                CyInterface().addImmediateMessage(CyTranslator().getText("TXT_KEY_FLIP_REFUSED", ()), "")
                                                gc.getTeam(gc.getPlayer(self.getNewCivFlip()).getTeam()).declareWar(iHuman, False) ##True??
                                                self.setBetrayalTurns(iBetrayalPeriod)
                                                self.initBetrayal()


                                        
                                                                
                                
        def rebellionPopup(self, iRebelCiv):
                self.showPopup(7622, CyTranslator().getText("TXT_KEY_REBELLION_TITLE", ()), \
                               CyTranslator().getText("TXT_KEY_INDEPENDENCE1", ()) + " " + \
                               gc.getPlayer(iRebelCiv).getCivilizationAdjective(0) + " " + \
                               CyTranslator().getText("TXT_KEY_REBELLION_MESSAGE", ()), \
                               (CyTranslator().getText("TXT_KEY_POPUP_YES", ()), \
                                CyTranslator().getText("TXT_KEY_POPUP_NO", ())))
                

        def eventApply7622(self, popupReturn):
                iHuman = utils.getHumanID()
                iRebelCiv = self.getRebelCiv()
                if( popupReturn.getButtonClicked() == 0 ): # 1st button
                        gc.getTeam(gc.getPlayer(iHuman).getTeam()).makePeace(iRebelCiv)                                                   
                elif( popupReturn.getButtonClicked() == 1 ): # 2nd button
                        gc.getTeam(gc.getPlayer(iHuman).getTeam()).declareWar(iRebelCiv, False)



#######################################
### Main methods (Event-Triggered) ###
#####################################  

        def setup(self):            

                #self.setupBirthTurnModifiers() (causes a crash on civ switch)
                
                self.create4000BCstartingUnits()
                #self.assign4000BCtechs()
                self.setEarlyLeaders()
                               
                # set starting gold
                pGreece.changeGold(100)
                pCarthage.changeGold(200)
                pRome.changeGold(100)
                pPersia.changeGold(200)
                pJapan.changeGold(100)
                pVikings.changeGold(150)
                pArabia.changeGold(300)
                pSpain.changeGold(200)
                pFrance.changeGold(150)    
                pEngland.changeGold(200)
                pGermany.changeGold(150)
                pRussia.changeGold(200)
                pMali.changeGold(800)
                pTurkey.changeGold(300)
                pInca.changeGold(700)
                pMongolia.changeGold(250) 
                pAztecs.changeGold(700)
                pAmerica.changeGold(1500)
               
           
                # display welcome message
                #self.displayWelcomePopup()

                #center camera on Egyptian units
                if (pEgypt.isHuman()):
                        plotEgypt = gc.getMap().plot(tCapitals[iEgypt][0], tCapitals[iEgypt][1])   
                        unit = plotEgypt.getUnit(0)
                        unit.centerCamera()
                        #print (unit)


        def setupBirthTurnModifiers(self):
                for iCiv in range(iNumPlayers):
                        if (iCiv >= iGreece and not gc.getPlayer(iCiv).isHuman()):
                                self.setBirthTurnModifier(iCiv, (gc.getGame().getSorenRandNum(11, 'BirthTurnModifier') - 5)) # -5 to +5
                #now make sure that no civs spawn in the same turn and cause a double "new civ" popup
                for iCiv in range(iNumPlayers):
                        if (iCiv > utils.getHumanID() and iCiv < iAmerica):
                                for j in range(iNumPlayers-1-iCiv):
                                        iNextCiv = iCiv+j+1
                                        if (con.tBirth[iCiv]+self.getBirthTurnModifier(iCiv) == con.tBirth[iNextCiv]+self.getBirthTurnModifier(iNextCiv)):
                                                self.setBirthTurnModifier(iNextCiv, (self.getBirthTurnModifier(iNextCiv)+1))



        def setEarlyLeaders(self):
                for i in range(iNumActivePlayers):
                        if (tEarlyLeaders[i] != tLeaders[i][0]):
                                if (not gc.getPlayer(i).isHuman()):
                                        gc.getPlayer(i).setLeader(tEarlyLeaders[i])
                                        print ("leader starting switch:", tEarlyLeaders[i], "in civ", i)
                                
        	
        def checkTurn(self, iGameTurn):

                #debug
                
                #pEgypt.changeGold(200)
                #teamEgypt.changeResearchProgress(con.iNationalism, 3299, iEgypt)
                #teamAztecs.changeResearchProgress(con.iSteel, 3399, iAztecs)

                #invasion attempt
                #if (iGameTurn == 100):
                #        utils.makeUnit(iAxeman, iGermany, tCapitals[iGermany], 3)
                #        utils.makeUnit(iSwordsman, iGermany, tCapitals[iGermany], 3)
                
                #for iCiv in range(iNumPlayers):
                #        for pyCity in PyPlayer(iCiv).getCityList():
                #                print (pyCity.GetCy().getName())

                
                #Trigger betrayal mode
                if (self.getBetrayalTurns() > 0):
                        self.initBetrayal()

                if (self.getCheatersCheck(0) > 0):
                        teamPlayer = gc.getTeam(gc.getPlayer(utils.getHumanID()).getTeam())
                        if (teamPlayer.isAtWar(self.getCheatersCheck(1))):
                                print ("No cheaters!")
                                self.initMinorBetrayal(self.getCheatersCheck(1))
                                self.setCheatersCheck(0, 0)
                                self.setCheatersCheck(1, -1)
                        else:
                                self.setCheatersCheck(0, self.getCheatersCheck(0)-1)

                if (iGameTurn % 15 == 0):
##                        if (pHolland.isAlive()):
##                                if (pGermany.isAlive()):                                    
##                                        utils.updateMinorTechs(iHolland, iGermany)
##                                if (pFrance.isAlive()):                                    
##                                        utils.updateMinorTechs(iHolland, iFrance)
##                                if (pVikings.isAlive()):                                    
##                                        utils.updateMinorTechs(iHolland, iVikings)                                    
##                                elif (pEngland.isAlive()):                                    
##                                        utils.updateMinorTechs(iEngland, iVikings)
##                        if (pPortugal.isAlive()):
##                                if (pSpain.isAlive()):                                    
##                                        utils.updateMinorTechs(iPortugal, iSpain)
##                                if (pFrance.isAlive()):                                    
##                                        utils.updateMinorTechs(iPortugal, iFrance)
##                                if (pRome.isAlive()):                                    
##                                        utils.updateMinorTechs(iPortugal, iRome)                                    
##                                elif (pCarthage.isAlive()):                                    
##                                        utils.updateMinorTechs(iPortugal, iCarthage)
                        if (pIndependent.isAlive()):                                  
                                utils.updateMinorTechs(iIndependent, iBarbarian)
                        if (pIndependent2.isAlive()):                                  
                                utils.updateMinorTechs(iIndependent2, iBarbarian)

                #Colonists
                if (iGameTurn >= (con.i1350AD + 5 + self.getColonistsAlreadyGiven(iSpain)*5)) and (iGameTurn <= con.i1918AD):
                        self.giveColonists(iSpain, tBroaderAreasTL[iSpain], tBroaderAreasBR[iSpain])
                if (iGameTurn >= (con.i1450AD + 5 + self.getColonistsAlreadyGiven(iEngland)*5)) and (iGameTurn <= con.i1918AD):
                        self.giveColonists(iEngland, tBroaderAreasTL[iEngland], tBroaderAreasBR[iEngland])
                if (iGameTurn >= (con.i1450AD + 5 + self.getColonistsAlreadyGiven(iFrance)*5)) and (iGameTurn <= con.i1918AD):
                        self.giveColonists(iFrance, tBroaderAreasTL[iFrance], tBroaderAreasBR[iFrance])
##                if (iGameTurn >= (con.i1400AD + self.getColonistsAlreadyGiven(iPortugal)*10)) and (iGameTurn <= con.i1918AD):
##                        self.giveColonists(iPortugal, tNormalAreasTL[iPortugal], tNormalAreasBR[iPortugal])
##                if (iGameTurn >= (con.i1500AD + self.getColonistsAlreadyGiven(iHolland)*10)) and (iGameTurn <= con.i1918AD):
##                        self.giveColonists(iHolland, tNormalAreasTL[iHolland], tNormalAreasBR[iHolland])
                        
                #birth of civs
                self.initBirth(iGameTurn, con.tBirth[iGreece]+self.getBirthTurnModifier(iGreece), iGreece)
                self.initBirth(iGameTurn, con.tBirth[iPersia]+self.getBirthTurnModifier(iPersia), iPersia)    
                self.initBirth(iGameTurn, con.tBirth[iCarthage]+self.getBirthTurnModifier(iCarthage), iCarthage)
                self.initBirth(iGameTurn, con.tBirth[iRome]+self.getBirthTurnModifier(iRome), iRome)
                self.initBirth(iGameTurn, con.tBirth[iJapan]+self.getBirthTurnModifier(iJapan), iJapan)
                self.initBirth(iGameTurn, con.tBirth[iVikings]+self.getBirthTurnModifier(iVikings), iVikings)
                self.initBirth(iGameTurn, con.tBirth[iArabia]+self.getBirthTurnModifier(iArabia), iArabia)
                self.initBirth(iGameTurn, con.tBirth[iSpain]+self.getBirthTurnModifier(iSpain), iSpain)
                self.initBirth(iGameTurn, con.tBirth[iFrance]+self.getBirthTurnModifier(iFrance), iFrance)
                self.initBirth(iGameTurn, con.tBirth[iEngland]+self.getBirthTurnModifier(iEngland), iEngland)
                self.initBirth(iGameTurn, con.tBirth[iGermany]+self.getBirthTurnModifier(iGermany), iGermany)
                self.initBirth(iGameTurn, con.tBirth[iRussia]+self.getBirthTurnModifier(iRussia), iRussia)
                self.initBirth(iGameTurn, con.tBirth[iMali]+self.getBirthTurnModifier(iMali), iMali)
                self.initBirth(iGameTurn, con.tBirth[iTurkey]+self.getBirthTurnModifier(iTurkey), iTurkey)
                self.initBirth(iGameTurn, con.tBirth[iInca]+self.getBirthTurnModifier(iInca), iInca)
                self.initBirth(iGameTurn, con.tBirth[iMongolia]+self.getBirthTurnModifier(iMongolia), iMongolia)
                self.initBirth(iGameTurn, con.tBirth[iAztecs]+self.getBirthTurnModifier(iAztecs), iAztecs)
                self.initBirth(iGameTurn, con.tBirth[iAmerica]+self.getBirthTurnModifier(iAmerica), iAmerica)

##                bHolland = self.minorBirth(iGameTurn, iHolland, tCapitals[iHolland], "Amsterdam", 3)
##                if (not bHolland):
##                        bHolland = self.minorBirth(iGameTurn, iHolland, con.tReserveCapitals[iHolland][0], "Amsterdam", 3)
##                if (not bHolland):
##                        bHolland = self.minorBirth(iGameTurn, iHolland, con.tReserveCapitals[iHolland][1], "Rotterdam", 3)
##                if (not bHolland):
##                        bHolland = self.minorBirth(iGameTurn, iHolland, con.tReserveCapitals[iHolland][2], "Groningen", 3)
##                bPortugal = self.minorBirth(iGameTurn, iPortugal, tCapitals[iPortugal], "Lisboa", 3)
##                if (not bPortugal):
##                        bPortugal =  self.minorBirth(iGameTurn, iPortugal, con.tReserveCapitals[iPortugal][0], "Lisboa", 3)
##                if (not bPortugal):
##                        bPortugal =  self.minorBirth(iGameTurn, iPortugal, con.tReserveCapitals[iPortugal][1], "Oporto", 3)
                        
                #flip Mesopotamia
                #if (iGameTurn == 1):
                #        self.convertSurroundingCities(iBabylonia, tBroaderAreasTL[iBabylonia], tBroaderAreasBR[iBabylonia])


                #fragment utility
                if (iGameTurn >= con.i50AD and iGameTurn % 15 == 6):
                        self.fragmentIndependents()
                if (iGameTurn >= con.i450AD and iGameTurn % 30 == 12):
                        self.fragmentBarbarians(iGameTurn)
                        
                #fall of civs
                if (iGameTurn >= con.i476AD and iGameTurn % 4 == 0):
                        self.collapseByBarbs(iGameTurn)                                        
                if (iGameTurn >= con.i2000BC and iGameTurn % 18 == 0): #used to be 15 in vanilla, because we must give some time for vassal states to form
                        self.collapseGeneric(iGameTurn)
                if (iGameTurn >= con.i2000BC and iGameTurn % 11 == 7): #used to be 8 in vanilla, because we must give some time for vassal states to form
                        self.collapseMotherland(iGameTurn)
                if (iGameTurn > con.i450AD and iGameTurn % 14 == 3):
                        self.secession(iGameTurn)
                #debug
                #self.collapseMotherland()

                #resurrection of civs
                if (gc.getGame().countCivPlayersEverAlive() - gc.getGame().countCivPlayersAlive() > 6): #3 in vanilla: here we must count natives and celts as dead too
                        if (iGameTurn % 20 == 15):
                                self.resurrection(iGameTurn)

                #debug
                #self.resurrection(iGameTurn)          
                #self.resurrectionFromBarbs(iGameTurn)




        def checkPlayerTurn(self, iGameTurn, iPlayer):
                #switch leader on first anarchy if early leader is different from primary one, and in a late game anarchy period to a late leader              
##                if (len(tLeaders[iPlayer]) > 1):
##                        if (tEarlyLeaders[iPlayer] != tLeaders[iPlayer][0]):
##                                if (iGameTurn > tBirth[iPlayer]+3 and iGameTurn < tBirth[iPlayer]+50):
##                                        if (gc.getPlayer(iPlayer).getAnarchyTurns() != 0):                                        
##                                                gc.getPlayer(iPlayer).setLeader(tLeaders[iPlayer][0])
##                                                print ("leader early switch:", tLeaders[iPlayer][0], "in civ", iPlayer)                        
##                        elif (iGameTurn >= tLateLeaders[iPlayer][1]):
##                                if (tLateLeaders[iPlayer][0] != tLeaders[iPlayer][0]):   
##                                        if (gc.getPlayer(iPlayer).getAnarchyTurns() != 0):                                                                                     
##                                                gc.getPlayer(iPlayer).setLeader(tLateLeaders[iPlayer][0])
##                                                print ("leader late switch:", tLateLeaders[iPlayer][0], "in civ", iPlayer) 
                if (len(tLeaders[iPlayer]) > 1):
                        if (len(tLateLeaders[iPlayer]) > 5):
                                if (iGameTurn >= tLateLeaders[iPlayer][5]):
                                        self.switchLateLeaders(iPlayer, 4)
                                elif (iGameTurn >= tLateLeaders[iPlayer][1]):
                                        self.switchLateLeaders(iPlayer, 0)
                        else:
                                if (iGameTurn >= tLateLeaders[iPlayer][1]):
                                        self.switchLateLeaders(iPlayer, 0)
            



        def switchLateLeaders(self, iPlayer, iLeaderIndex):
                if (tLateLeaders[iPlayer][iLeaderIndex] != gc.getPlayer(iPlayer).getLeader()):
                        iThreshold = tLateLeaders[iPlayer][iLeaderIndex+2]
                        if (gc.getPlayer(iPlayer).getCurrentEra() >= tLateLeaders[iPlayer][iLeaderIndex+3]):
                                iThreshold *= 2
                        if (gc.getPlayer(iPlayer).getAnarchyTurns() != 0 or \
                            utils.getPlagueCountdown(iPlayer) > 0 or \
                            utils.getGreatDepressionCountdown(iPlayer) > 0 or \
                            utils.getStability(iPlayer) <= -10 or \
                            gc.getGame().getSorenRandNum(100, 'die roll') < iThreshold):
                                gc.getPlayer(iPlayer).setLeader(tLateLeaders[iPlayer][iLeaderIndex])
                                print ("leader late switch:", tLateLeaders[iPlayer][iLeaderIndex], "in civ", iPlayer)       
            
            

        def fragmentIndependents(self):

                if (pIndependent.getNumCities() > 8 or pIndependent2.getNumCities() > 8 ):
                        iBigIndependent = -1
                        iSmallIndependent = -1
                        if (pIndependent.getNumCities() > 2*pIndependent2.getNumCities()):
                                iBigIndependent = iIndependent
                                iSmallIndependent = iIndependent2
                        if (2*pIndependent.getNumCities() < 2*pIndependent2.getNumCities()):
                                iBigIndependent = iIndependent2
                                iSmallIndependent = iIndependent
                        if (iBigIndependent != -1):
                                iDivideCounter = 0
                                iCounter = 0
                                cityList = []
                                apCityList = PyPlayer(iBigIndependent).getCityList()
                                for pCity in apCityList:
                                        iDivideCounter += 1 #convert 3 random cities cycling just once
                                        if (iDivideCounter % 2 == 1):
                                                city = pCity.GetCy()
                                                pCurrent = gc.getMap().plot(city.getX(), city.getY())                                        
                                                utils.cultureManager((city.getX(),city.getY()), 50, iSmallIndependent, iBigIndependent, False, True, True)
                                                utils.flipUnitsInCityBefore((city.getX(),city.getY()), iSmallIndependent, iBigIndependent)                            
                                                self.setTempFlippingCity((city.getX(),city.getY()))
                                                utils.flipCity((city.getX(),city.getY()), 0, 0, iSmallIndependent, [iBigIndependent])   #by trade because by conquest may raze the city
                                                utils.flipUnitsInCityAfter(self.getTempFlippingCity(), iSmallIndependent)
                                                iCounter += 1
                                                if (iCounter == 3):
                                                        return



        def fragmentBarbarians(self, iGameTurn):

                iRndnum = gc.getGame().getSorenRandNum(iNumPlayers, 'starting count')
                for j in range(iRndnum, iRndnum + iNumPlayers):
                        iDeadCiv = j % iNumPlayers                                                        
                        if (not gc.getPlayer(iDeadCiv).isAlive() and iGameTurn > con.tBirth[iDeadCiv] + 50):
                                pDeadCiv = gc.getPlayer(iDeadCiv)
                                teamDeadCiv = gc.getTeam(pDeadCiv.getTeam())
                                iCityCounter = 0
                                for x in range(tNormalAreasTL[iDeadCiv][0], tNormalAreasBR[iDeadCiv][0]+1):
                                        for y in range(tNormalAreasTL[iDeadCiv][1], tNormalAreasBR[iDeadCiv][1]+1):
                                                pCurrent = gc.getMap().plot( x, y )
                                                if ( pCurrent.isCity()):
                                                        if (pCurrent.getPlotCity().getOwner() == iBarbarian):
                                                                iCityCounter += 1
                                if (iCityCounter > 3):
                                        iDivideCounter = 0
                                        for x in range(tNormalAreasTL[iDeadCiv][0], tNormalAreasBR[iDeadCiv][0]+1):
                                                for y in range(tNormalAreasTL[iDeadCiv][1], tNormalAreasBR[iDeadCiv][1]+1):
                                                        pCurrent = gc.getMap().plot( x, y )
                                                        if ( pCurrent.isCity()):
                                                                city = pCurrent.getPlotCity()
                                                                if (city.getOwner() == iBarbarian):
                                                                        if (iDivideCounter % 4 == 0):
                                                                                iNewCiv = iIndependent
                                                                        elif (iDivideCounter % 4 == 1):
                                                                                iNewCiv = iIndependent2
                                                                        if (iDivideCounter % 4 == 0 or iDivideCounter % 4 == 1):
                                                                                utils.cultureManager((city.getX(),city.getY()), 50, iNewCiv, iBarbarian, False, True, True)
                                                                                utils.flipUnitsInCityBefore((city.getX(),city.getY()), iNewCiv, iBarbarian)                            
                                                                                self.setTempFlippingCity((city.getX(),city.getY()))
                                                                                utils.flipCity((city.getX(),city.getY()), 0, 0, iNewCiv, [iBarbarian])   #by trade because by conquest may raze the city
                                                                                utils.flipUnitsInCityAfter(self.getTempFlippingCity(), iNewCiv)
                                                                                iDivideCounter += 1
                                        return






##        def collapseCapitals(self, iOldOwner, city, iNewOwner):
##        #Persian UP inside
##        #AI tweaked in CvCity::getCulturePercentAnger()
##        
##                bCapital = False
##                bPersia = False
##                iModifier = 0
##                for i in range(iNumPlayers):
##                        if (city.getX() == tCapitals[i][0] and city.getY() == tCapitals[i][1]):
##                                if (city.getOwner() == i): #otherwise it's no longer a capital
##                                        bCapital = True                                
##                if (iNewOwner == iPersia):
##                        bPersia = True
##                        if (not bCapital):
##                                iModifier = 1
##                if (iNewOwner == self.getRebelCiv() and gc.getGame().getGameTurn() == self.getLatestRebellionTurn(self.getRebelCiv())):
##                        return #don't mess up with resurrection()
##                #print ("iNewOwner", iNewOwner, con.tBirth[iNewOwner])
##                if (iNewOwner == iBarbarian):
##                        return
##                if (iNewOwner != iBarbarian):
##                        if (gc.getGame().getGameTurn() <= con.tBirth[iNewOwner] + 2):
##                                return #don't mess up with birth (case of delay still a problem...)
##                if (bCapital or bPersia):
##                        for x in range(city.getX() -3 +iModifier, city.getX() +4 -iModifier):
##                                for y in range(city.getY() -3 +iModifier, city.getY() +4 -iModifier):
##                                        pCurrent = gc.getMap().plot( x, y )
##                                        if ( pCurrent.isCity()):
##                                                cityNear = pCurrent.getPlotCity()
##                                                iOwnerNear = cityNear.getOwner()
##                                                #print ("iOwnerNear", iOwnerNear, "citynear", cityNear.getName())
##                                                if (iOwnerNear != iNewOwner and iOwnerNear == iOldOwner):
##                                                        if (cityNear != city):
##                                                                if (cityNear.getPopulation() <= city.getPopulation() and not cityNear.isCapital()):
##                                                                        if (bPersia == True and iModifier == 1): #Persian UP - any city, 2x2 area
##                                                                                if (cityNear.getPopulation() <= 8):
##                                                                                        if (self.getLatestFlipTurn() != gc.getGame().getGameTurn()):                                                                               
##                                                                                                utils.flipUnitsInCityBefore((x,y), iNewOwner, iOwnerNear)
##                                                                                                self.setTempFlippingCity((x,y))
##                                                                                                utils.flipCity((x,y), 0, 0, iNewOwner, [iOwnerNear])
##                                                                                                utils.flipUnitsInCityAfter(self.getTempFlippingCity(), iNewOwner)
##                                                                                                self.setLatestFlipTurn(gc.getGame().getGameTurn())
##                                                                                                utils.cultureManager(self.getTempFlippingCity(), 50, iOwnerNear, iNewOwner, False, False, False)
##                                                                        else:   
##                                                                                utils.flipUnitsInCityBefore((x,y), iNewOwner, iOwnerNear)
##                                                                                self.setTempFlippingCity((x,y))
##                                                                                utils.flipCity((x,y), 0, 0, iNewOwner, [iOwnerNear])
##                                                                                utils.flipUnitsInCityAfter(self.getTempFlippingCity(), iNewOwner)
##                                                                                utils.cultureManager(self.getTempFlippingCity(), 50, iOwnerNear, iNewOwner, False, False, False)
##                                                                                print ("COLLAPSE: CAPITALS", gc.getPlayer(iOwnerNear).getCivilizationShortDescription(0))
                                                                                     

                            

        def collapseByBarbs(self, iGameTurn):
                for iCiv in range(iNumPlayers):
                        if (gc.getPlayer(iCiv).isHuman() == 0 and gc.getPlayer(iCiv).isAlive()):
                                if (iGameTurn >= con.tBirth[iCiv] + 25):
                                        iNumCities = gc.getPlayer(iCiv).getNumCities()
                                        iLostCities = 0
                                        for x in range(0, 124):
                                                for y in range(0, 168):
                                                        if (gc.getMap().plot( x,y ).isCity()):
                                                                city = gc.getMap().plot( x,y ).getPlotCity()
                                                                if (city.getOwner() == iBarbarian):
                                                                        if (city.getOriginalOwner() == iCiv):
                                                                                iLostCities = iLostCities + 1                                                
                                        if (iLostCities*2 > iNumCities and iNumCities > 0): #if more than one third is captured, the civ collapses
                                                print ("COLLAPSE BY BARBS", gc.getPlayer(iCiv).getCivilizationAdjective(0))
                                                utils.killAndFragmentCiv(iCiv, iIndependent, iIndependent2, -1, False)

        def collapseGeneric(self, iGameTurn):
                lNumCitiesNew = con.l0Array
                for iCiv in range(con.iNumPlayers):
                        pCiv = gc.getPlayer(iCiv)
                        teamCiv = gc.getTeam(pCiv.getTeam())
                        if (pCiv.isAlive()):
                                if (iGameTurn >= con.tBirth[iCiv] + 25):
                                        lNumCitiesNew[iCiv] = pCiv.getNumCities()
                                        if (lNumCitiesNew[iCiv]*2 <= self.getNumCities(iCiv)): #if number of cities is less than half than some turns ago, the civ collapses
                                                print ("COLLAPSE GENERIC", pCiv.getCivilizationAdjective(0), lNumCitiesNew[iCiv]*2, "<=", self.getNumCities(iCiv))
                                                if (gc.getPlayer(iCiv).isHuman() == 0):
                                                        bVassal = False
                                                        for iMaster in range(con.iNumPlayers):
                                                                if (teamCiv.isVassal(iMaster)):
                                                                        bVassal = True
                                                                        break
                                                        if (not bVassal):
                                                                utils.killAndFragmentCiv(iCiv, iIndependent, iIndependent2, -1, False)
                                        else:
                                                self.setNumCities(iCiv, lNumCitiesNew[iCiv])

        def collapseMotherland(self, iGameTurn):
                #collapses if completely out of broader areas
                for iCiv in range(iNumPlayers):
                        pCiv = gc.getPlayer(iCiv)
                        teamCiv = gc.getTeam(pCiv.getTeam())
                        if (pCiv.isHuman() == 0 and pCiv.isAlive()):
                                if (iGameTurn >= con.tBirth[iCiv] + 25):
                                        bSafe = False
                                        for x in range(tCoreAreasTL[iCiv][0], tCoreAreasBR[iCiv][0]+1):
                                                for y in range(tCoreAreasTL[iCiv][1], tCoreAreasBR[iCiv][1]+1):
                                                        pCurrent = gc.getMap().plot( x, y )
                                                        if ( pCurrent.isCity()):
                                                                #print (pCurrent.getPlotCity().getOwner(), pCurrent.getPlotCity().getName(), pCurrent.getPlotCity().getX(), pCurrent.getPlotCity().getY())
                                                                if (pCurrent.getPlotCity().getOwner() == iCiv):
                                                                        #print ("iCiv", iCiv, "bSafe", bSafe)
                                                                        bSafe = True
                                                                        break
                                                                        break
                                        if (bSafe == False):
                                                iCitiesOwned = 0
                                                iCitiesLost = 0
                                                for x in range(tNormalAreasTL[iCiv][0], tNormalAreasBR[iCiv][0]+1):
                                                        for y in range(tNormalAreasTL[iCiv][1], tNormalAreasBR[iCiv][1]+1):
                                                                pCurrent = gc.getMap().plot( x, y )
                                                                if ( pCurrent.isCity()):
                                                                        #print (pCurrent.getPlotCity().getOwner(), pCurrent.getPlotCity().getName(), pCurrent.getPlotCity().getX(), pCurrent.getPlotCity().getY())
                                                                        if (pCurrent.getPlotCity().getOwner() == iCiv):
                                                                                iCitiesOwned += 1
                                                                        else:
                                                                                iCitiesLost += 1
                                                if (iCitiesOwned > iCitiesLost):
                                                        bSafe = True
                                        #print ("iCiv", iCiv, "bSafe", bSafe)
                                        if (bSafe == False):
                                                bVassal = False
                                                for iMaster in range(con.iNumPlayers):
                                                        if (teamCiv.isVassal(iMaster)):
                                                                bVassal = True
                                                                break
                                                if (not bVassal):
                                                        print ("COLLAPSE: MOTHERLAND", gc.getPlayer(iCiv).getCivilizationAdjective(0))
                                                        utils.killAndFragmentCiv(iCiv, iIndependent, iIndependent2, -1, False)
                                                return
                        


        def collapseHuman(self, iOldOwner, city, iNewOwner):
                bEnabled = False
                bCapital = False
                bGeneric = False
                
                if (gc.getTeam(gc.getPlayer(iNewOwner).getTeam()).isHasTech(con.iCodeOfLaws)):
                        bEnabled = True
                                    
                iHuman = utils.getHumanID()
                if (city.getX() == tCapitals[iHuman][0] and city.getY() == tCapitals[iHuman][1]):
                        bCapital = True

                print ("bEnabled:", bEnabled, "bCapital:", bCapital, "bGeneric:", bGeneric)

                #debug
                #gc.getTeam(gc.getPlayer(iJapan).getTeam()).setVassal(iIndia, True, False)
                #gc.getTeam(gc.getPlayer(iMongolia).getTeam()).setVassal(iIndia, True, False)
                #gc.getTeam(gc.getPlayer(iCarthage).getTeam()).setVassal(iSpain, True, False)
                #gc.getTeam(gc.getPlayer(iMali).getTeam()).setVassal(iSpain, True, False)

                #iNumCitiesNew = gc.getPlayer(iHuman).getNumCities()
                #if (iNumCitiesNew*2 <= self.getNumCities(iHuman)):
                #        print ("HumanCollapseGeneric", iNumCitiesNew*2, "<=", self.getNumCities(iHuman))
                #        bGeneric = True

                #debug
                #bEnabled = True
                #bCapital = True
                
                if ((bCapital or bGeneric) and bEnabled):
                        self.exile(iNewOwner)


        def exile(self, iWinner):
                iHuman = utils.getHumanID()
                pWinner = gc.getPlayer(iWinner)
                teamWinner = gc.getTeam(pWinner.getTeam())
                iDestination = -1
                iRndnum = gc.getGame().getSorenRandNum(iNumPlayers, 'start index')
                for i in range( iRndnum, iNumPlayers + iRndnum ):
                        iCiv = i % iNumPlayers
                        if (gc.getPlayer(iCiv).isAlive() and iCiv != iWinner):
                                if (pWinner.canContact(iCiv)):
                                        if (not teamWinner.isAtWar(iCiv)):
                                                if (gc.getGame().getPlayerRank(iCiv) > gc.getGame().getPlayerRank(iHuman) + 1):
                                                        iDestination = iCiv
                                                        break                                          

                print (iDestination)
                popup = Popup.PyPopup()
                popup.setHeaderString(CyTranslator().getText("TXT_KEY_EXILE_TITLE", ()))          
                popup.setBodyString( CyTranslator().getText("TXT_KEY_EXILE_TEXT1", ()) + " " + gc.getPlayer(iWinner).getCivilizationAdjective(0) + " " + CyTranslator().getText("TXT_KEY_EXILE_TEXT2", ()) + " " + gc.getPlayer(iDestination).getCivilizationShortDescription(0) + CyTranslator().getText("TXT_KEY_EXILE_TEXT3", ()))
                popup.launch()
                self.setExileData(0, tCapitals[iHuman][0])
                self.setExileData(1, tCapitals[iHuman][1])
                self.setExileData(2, gc.getGame().getGameTurn())
                self.setExileData(3, iHuman)
                self.setExileData(4, iWinner)

                for iMaster in range(con.iNumPlayers):
                        if (gc.getTeam(gc.getPlayer(iDestination).getTeam()).isVassal(iMaster)):
                                gc.getTeam(gc.getPlayer(iDestination).getTeam()).setVassal(iMaster, False, False)
                
                iTempHumanLeader = gc.getPlayer(iHuman).getLeader()
                iTempDestinationLeader = gc.getPlayer(iDestination).getLeader()
                gc.getPlayer(iDestination).setLeader(iTempHumanLeader)
                gc.getGame().setActivePlayer(iDestination, False)
                gc.getPlayer(iHuman).setLeader(iTempDestinationLeader)
                teamWinner.makePeace(iHuman) #now managed by AI
                iTempLeader = gc.getPlayer(iHuman)

                

        def escape(self, city):
                if (gc.getGame().getGameTurn() <= self.getExileData(2) + iEscapePeriod):
                        iOldHuman = self.getExileData(3)
                        if (gc.getPlayer(iOldHuman).isAlive()):
                                iHuman = utils.getHumanID()
                                utils.flipCity((city.getX(),city.getY()), 0, 0, iOldHuman, [iHuman])
                                popup = Popup.PyPopup()
                                popup.setHeaderString(CyTranslator().getText("TXT_KEY_ESCAPE_TITLE", ()))          
                                popup.setBodyString( CyTranslator().getText("TXT_KEY_ESCAPE_TEXT1", ()) + " " + gc.getPlayer(iOldHuman).getCivilizationAdjective(0) + " " + CyTranslator().getText("TXT_KEY_ESCAPE_TEXT2", ()))
                                popup.launch()

                                for iMaster in range(con.iNumPlayers):
                                        if (gc.getTeam(gc.getPlayer(iOldHuman).getTeam()).isVassal(iMaster)):
                                                gc.getTeam(gc.getPlayer(iOldHuman).getTeam()).setVassal(iMaster, False, False)
                                
                                iTempHumanLeader = gc.getPlayer(iHuman).getLeader()
                                iTempOldHumanLeader = gc.getPlayer(iOldHuman).getLeader()
                                gc.getPlayer(iOldHuman).setLeader(iTempHumanLeader)
                                gc.getGame().setActivePlayer(iOldHuman, False)
                                gc.getPlayer(iHuman).setLeader(iTempOldHumanLeader)
                                city.setHasRealBuilding((0), True) #0 == palace
                                teamWinner = gc.getTeam(gc.getPlayer(self.getExileData(4)).getTeam())
                                teamWinner.declareWar(iOldHuman, True)
                                teamWinner.makePeace(iHuman) #now managed by AI
                                self.setExileData(0, -1)
                                self.setExileData(1, -1)
                                self.setExileData(2, -1)
                                self.setExileData(3, -1)
                                self.setExileData(4, -1)

                

        def secession(self, iGameTurn):
            
                iRndnum = gc.getGame().getSorenRandNum(iNumPlayers, 'starting count')
                for j in range(iRndnum, iRndnum + iNumPlayers):
                        iPlayer = j % iNumPlayers   
                        if (gc.getPlayer(iPlayer).isAlive() and iGameTurn >= con.tBirth[iPlayer] + 30):
                                if (utils.getStability(iPlayer) >= -40 and utils.getStability(iPlayer) < -20): #secession

                                        cityList = []
                                        apCityList = PyPlayer(iPlayer).getCityList()
                                        for pCity in apCityList:
                                                city = pCity.GetCy()
                                                pCurrent = gc.getMap().plot(city.getX(), city.getY())

                                                if ((not city.isWeLoveTheKingDay()) and (not city.isCapital()) and (not (city.getX() == tCapitals[iPlayer][0] and city.getY() == tCapitals[iPlayer][1]))):
                                                        if (gc.getPlayer(iPlayer).getNumCities() > 0): #this check is needed, otherwise game crashes
                                                                capital = gc.getPlayer(iPlayer).getCapitalCity()
                                                                iDistance = utils.calculateDistance(city.getX(), city.getY(), capital.getX(), capital.getY())
                                                                if (iDistance > 3):                                                                                               
                                                            
                                                                        if (city.angryPopulation(0) > 0 or \
                                                                            city.healthRate(False, 0) < 0 or \
                                                                            city.getReligionBadHappiness() > 0 or \
                                                                            city.getLargestCityHappiness() < 0 or \
                                                                            city.getHurryAngerModifier() > 0 or \
                                                                            city.getNoMilitaryPercentAnger() > 0 or \
                                                                            city.getWarWearinessPercentAnger() > 0):
                                                                                cityList.append(city)
                                                                                continue
                                                                        
                                                                        for iLoop in range(iNumTotalPlayers+1):
                                                                                if (iLoop != iPlayer):
                                                                                        if (pCurrent.getCulture(iLoop) > 0):
                                                                                                cityList.append(city)
                                                                                                break

                                        if (len(cityList)):
                                                iNewCiv = iIndependent
                                                iRndNum = gc.getGame().getSorenRandNum(2, 'random independent')
                                                if (iRndNum % 2 == 0):
                                                        iNewCiv = iIndependent2                        
                                                splittingCity = cityList[gc.getGame().getSorenRandNum(len(cityList), 'random city')]
                                                utils.cultureManager((splittingCity.getX(),splittingCity.getY()), 50, iNewCiv, iPlayer, False, True, True)
                                                utils.flipUnitsInCityBefore((splittingCity.getX(),splittingCity.getY()), iNewCiv, iPlayer)                            
                                                self.setTempFlippingCity((splittingCity.getX(),splittingCity.getY()))
                                                utils.flipCity((splittingCity.getX(),splittingCity.getY()), 0, 0, iNewCiv, [iPlayer])   #by trade because by conquest may raze the city
                                                utils.flipUnitsInCityAfter(self.getTempFlippingCity(), iNewCiv)
                                                if (iPlayer == utils.getHumanID()):
                                                        CyInterface().addImmediateMessage(splittingCity.getName() + " " + \
                                                                                           CyTranslator().getText("TXT_KEY_STABILITY_SECESSION", ()), "")
                                                print ("SECESSION", gc.getPlayer(iPlayer).getCivilizationAdjective(0), splittingCity.getName())
                                                utils.setStability(iPlayer, utils.getStability(iPlayer) + 5) #to counterbalance the stability hit on city acquired event, leading to a chain reaction
                                        return #just 1 secession per turn


                              
        def resurrection(self, iGameTurn):
                iMinNumCities = 2
                bEnabled = False
                for iCiv in range(iNumActivePlayers):
                        pCiv = gc.getPlayer(iCiv)
                        teamCiv = gc.getTeam(pCiv.getTeam())
                        if (pCiv.isAlive()):
                                if (teamCiv.isHasTech(con.iNationalism)):
                                        bEnabled = True
                                        break
                                #debug
                                #bEnabled = True
                                #break
                #print ("bEnabled", bEnabled)
                if (bEnabled):
                        iRndnum = gc.getGame().getSorenRandNum(iNumPlayers, 'starting count')
                        cityList = []
                        for j in range(iRndnum, iRndnum + iNumPlayers):
                                iDeadCiv = j % iNumPlayers                                
                                if (not gc.getPlayer(iDeadCiv).isAlive() and iGameTurn > con.tBirth[iDeadCiv] + 50):
                                        pDeadCiv = gc.getPlayer(iDeadCiv)
                                        teamDeadCiv = gc.getTeam(pDeadCiv.getTeam())
                                        cityList = []
                                        tTopLeft = tNormalAreasTL[iDeadCiv]
                                        tBottomRight = tNormalAreasBR[iDeadCiv]
                                        #if (self.getLatestRebellionTurn(iDeadCiv) > 0):
                                        #        tTopLeft = tNormalAreasTL[iDeadCiv]
                                        #        tBottomRight = tNormalAreasBR[iDeadCiv]
                                        #else:
                                        #        tTopLeft = tCoreAreasTL[iDeadCiv]
                                        #        tBottomRight = tCoreAreasBR[iDeadCiv]
                                        for x in range(tTopLeft[0], tBottomRight[0]+1):
                                                for y in range(tTopLeft[1], tBottomRight[1]+1):
                                                        pCurrent = gc.getMap().plot( x, y )
                                                        if ( pCurrent.isCity()):
                                                                city = pCurrent.getPlotCity()
                                                                iOwner = city.getOwner()
                                                                if (iOwner == iBarbarian or iOwner == iIndependent or iOwner == iIndependent2): #remove in vanilla
                                                                        cityList.append(pCurrent.getPlotCity())
                                                                        #print (iDeadCiv, pCurrent.getPlotCity().getName(), pCurrent.getPlotCity().getOwner(), "1", cityList)
                                                                else:
                                                                        if (gc.getPlayer(iOwner).getNumCities() > 3):
                                                                                if (utils.getStability(iOwner) < -20):
                                                                                        if (not city.isWeLoveTheKingDay() and not city.isCapital()):
                                                                                                    cityList.append(pCurrent.getPlotCity())
                                                                                                    #print (iDeadCiv, pCurrent.getPlotCity().getName(), pCurrent.getPlotCity().getOwner(), "2", cityList)
                                                                                elif (utils.getStability(iOwner) < 0):
                                                                                        if (not city.isWeLoveTheKingDay() and not city.isCapital() and (not (city.getX() == tCapitals[iOwner][0] and city.getY() == tCapitals[iOwner][1]))):
                                                                                                if (gc.getPlayer(iOwner).getNumCities() > 0): #this check is needed, otherwise game crashes
                                                                                                        capital = gc.getPlayer(iOwner).getCapitalCity()
                                                                                                        iDistance = utils.calculateDistance(x, y, capital.getX(), capital.getY())
                                                                                                        if ((iDistance >= 8 and gc.getPlayer(iOwner).getNumCities() >= 5) or \
                                                                                                            city.angryPopulation(0) > 0 or \
                                                                                                            city.healthRate(False, 0) < 0 or \
                                                                                                            city.getReligionBadHappiness() > 0 or \
                                                                                                            city.getLargestCityHappiness() < 0 or \
                                                                                                            city.getHurryAngerModifier() > 0 or \
                                                                                                            city.getNoMilitaryPercentAnger() > 0 or \
                                                                                                            city.getWarWearinessPercentAnger() > 0):
                                                                                                                    cityList.append(pCurrent.getPlotCity())
                                                                                                                    #print (iDeadCiv, pCurrent.getPlotCity().getName(), pCurrent.getPlotCity().getOwner(), "3", cityList)
                                                if (len(cityList) >= iMinNumCities):
                                                        if (gc.getGame().getSorenRandNum(100, 'roll') < con.tResurrectionProb[iDeadCiv]):
                                                                break
                        if (len(cityList) >= iMinNumCities):
                                self.setRebelCiv(iDeadCiv) #for popup and CollapseCapitals()
                                if (len(tLeaders[iDeadCiv]) > 1):
                                        iLen = len(tLeaders[iDeadCiv])
                                        iRnd = gc.getGame().getSorenRandNum(iLen, 'odds')
                                        for k in range (iLen):
                                                iLeader = (iRnd + k) % iLen
                                                if (pDeadCiv.getLeader() != tLeaders[iDeadCiv][iLeader]):
                                                        print ("leader switch after resurrection", pDeadCiv.getLeader(), tLeaders[iDeadCiv][iLeader])
                                                        pDeadCiv.setLeader(tLeaders[iDeadCiv][iLeader])
                                                        break                                                        
                                                
                                for l in range(iNumPlayers):
                                        teamDeadCiv.makePeace(l)
                                self.setNumCities(iDeadCiv, 0) #reset collapse condition
                                for t in range(con.iNumTechs):
                                        if (teamBarbarian.isHasTech(t)):
                                                teamDeadCiv.setHasTech(t, True, iDeadCiv, False, False)
                                utils.setBaseStabilityLastTurn(iDeadCiv, 0)
                                utils.setStability(iDeadCiv, -1) #the new civs start as shaky
                                iNewUnits = 2
                                if (self.getLatestRebellionTurn(iDeadCiv) > 0):
                                        iNewUnits = 4
                                self.setLatestRebellionTurn(iDeadCiv, iGameTurn)
                                bHuman = False
                                iHuman = utils.getHumanID()
                                print ("INDEPENDENCE", gc.getPlayer(iDeadCiv).getCivilizationAdjective(0))
                                for k in range(len(cityList)):
                                        print ("INDEPENDENCE: ", cityList[k].getName())
                                        ownersList = []
                                        bAlreadyVassal = False
                                        iOwner = cityList[k].getOwner()
                                        teamOwner = gc.getTeam(gc.getPlayer(iOwner).getTeam())
                                        
                                        if (iOwner == iHuman):
                                                bHuman = True

                                        if (iOwner == iBarbarian or iOwner == iIndependent or iOwner == iIndependent2):
                                                utils.cultureManager((cityList[k].getX(),cityList[k].getY()), 100, iDeadCiv, iOwner, False, True, True)
                                                utils.flipUnitsInCityBefore((cityList[k].getX(),cityList[k].getY()), iDeadCiv, iOwner)
                                                self.setTempFlippingCity((cityList[k].getX(),cityList[k].getY()))
                                                utils.flipCity((cityList[k].getX(),cityList[k].getY()), 0, 0, iDeadCiv, [iOwner])
                                                tCoords = self.getTempFlippingCity()
                                                utils.flipUnitsInCityAfter(tCoords, iOwner)
                                                utils.flipUnitsInArea((tCoords[0]-2, tCoords[1]-2), (tCoords[0]+2, tCoords[1]+2), iDeadCiv, iOwner, True, False)
                                        else:
                                                utils.cultureManager((cityList[k].getX(),cityList[k].getY()), 50, iDeadCiv, iOwner, False, True, True)
                                                utils.pushOutGarrisons((cityList[k].getX(),cityList[k].getY()), iOwner)
                                                utils.relocateSeaGarrisons((cityList[k].getX(),cityList[k].getY()), iOwner)                                                                        
                                                self.setTempFlippingCity((cityList[k].getX(),cityList[k].getY()))
                                                utils.flipCity((cityList[k].getX(),cityList[k].getY()), 0, 0, iDeadCiv, [iOwner])   #by trade because by conquest may raze the city
                                                utils.createGarrisons(self.getTempFlippingCity(), iDeadCiv, iNewUnits)                                         
                                            
                                        if (iOwner != iHuman and iOwner not in ownersList): #declare war or peace only once
                                                rndNum = gc.getGame().getSorenRandNum(100, 'odds')
                                                if (rndNum >= tAIStopBirthThreshold[iOwner]):
                                                        teamOwner.declareWar(iDeadCiv, False)
                                                elif (rndNum >= tAIStopBirthThreshold[iOwner]/2):
                                                        teamOwner.makePeace(iDeadCiv)
                                                        if (bAlreadyVassal == False):
                                                                if (iOwner != iBarbarian and iOwner != iIndependent and iOwner != iIndependent2):
                                                                        gc.getTeam(gc.getPlayer(iDeadCiv).getTeam()).setVassal(iOwner, True, False)  #remove in vanilla
                                                                        bAlreadyVassal = True
                                                else:
                                                        teamOwner.makePeace(iDeadCiv)
                                                ownersList.append(iOwner)
                                                        
                                CyInterface().addImmediateMessage((CyTranslator().getText("TXT_KEY_INDEPENDENCE1", ()) + " " + \
                                                            pDeadCiv.getCivilizationAdjective(0) + " " + \
                                                            CyTranslator().getText("TXT_KEY_INDEPENDENCE2", ())), "")
                                if (bHuman == True):
                                        self.rebellionPopup(iDeadCiv)   
                                utils.setStability(iDeadCiv, -5) #again, cos acquiring cities would make the new civ very stable
                                utils.setPlagueCountdown(iDeadCiv, -10)
                                return
                            
                                    
        def initBirth(self, iCurrentTurn, iBirthYear, iCiv):
                iHuman = utils.getHumanID()
                if (iCurrentTurn == iBirthYear-1 + self.getSpawnDelay(iCiv) + self.getFlipsDelay(iCiv)):
                        tCapital = tCapitals[iCiv]
                        tTopLeft = tCoreAreasTL[iCiv]
                        tBottomRight = tCoreAreasBR[iCiv]
                        tBroaderTopLeft = tBroaderAreasTL[iCiv]
                        tBroaderBottomRight = tBroaderAreasBR[iCiv]                    
                        if (self.getFlipsDelay(iCiv) == 0): #city hasn't already been founded)
                                bDeleteEverything = False
                                if (gc.getMap().plot(tCapital[0], tCapital[1]).isOwned()):
                                        if (iCiv == iHuman or not gc.getPlayer(iHuman).isAlive()):
                                                bDeleteEverything = True
                                                print ("bDeleteEverything 1")
                                        else:
                                                bDeleteEverything = True
                                                for x in range(tCapital[0] - 1, tCapital[0] + 2):        # from x-1 to x+1
                                                        for y in range(tCapital[1] - 1, tCapital[1] + 2):	# from y-1 to y+1
                                                                pCurrent=gc.getMap().plot(x, y)
                                                                if (pCurrent.isCity() or pCurrent.isVisible(iHuman, False)):
                                                                        bDeleteEverything = False
                                                                        print ("bDeleteEverything 2")
                                                                        break
                                                                        break
                                print ("bDeleteEverything", bDeleteEverything)
                                if (not gc.getMap().plot(tCapital[0], tCapital[1]).isOwned()):
                                        self.birthInFreeRegion(iCiv, tCapital, tTopLeft, tBottomRight)
                                elif (bDeleteEverything):
                                        for x in range(tCapital[0] - 1, tCapital[0] + 2):        # from x-1 to x+1
                                                for y in range(tCapital[1] - 1, tCapital[1] + 2):	# from y-1 to y+1
                                                        self.setDeleteMode(iCiv)
                                                        #print ("deleting", x, y)
                                                        pCurrent=gc.getMap().plot(x, y)
                                                        pCurrent.eraseAIDevelopment() #new function, similar to erase but won't delete rivers, resources and features()
                                                        for iLoopCiv in range(iNumTotalPlayers+1): #Barbarians as well
                                                                pCurrent.setCulture(iLoopCiv, 0, True)
                                                        pCurrent.setOwner(-1)
                                        self.birthInFreeRegion(iCiv, tCapital, tTopLeft, tBottomRight)
                                else:                                
                                        self.birthInForeignBorders(iCiv, tTopLeft, tBottomRight, tBroaderTopLeft, tBroaderBottomRight)
                        else:
                                print ( "setBirthType again: flips" )
                                self.birthInFreeRegion(iCiv, tCapital, tTopLeft, tBottomRight)
                                       
                if (iCurrentTurn == iBirthYear + self.getSpawnDelay(iCiv)) and (gc.getPlayer(iCiv).isAlive()) and (self.getAlreadySwitched() == False) and (iHuman+tDifference[iHuman] < iCiv):
                        self.newCivPopup(iCiv)   


        def deleteMode(self, iCurrentPlayer):
                iCiv = self.getDeleteMode()
                print ("deleteMode after", iCurrentPlayer)
                tCapital = con.tCapitals[iCiv]
                if (iCurrentPlayer == iCiv):
                        for x in range(tCapital[0] - 2, tCapital[0] + 3):        # from x-2 to x+2
                                for y in range(tCapital[1] - 2, tCapital[1] + 3):	# from y-2 to y+2
                                        pCurrent=gc.getMap().plot(x, y)
                                        pCurrent.setCulture(iCiv, 100, True)
                        for x in range(tCapital[0] - 1, tCapital[0] + 2):        # from x-1 to x+1
                                for y in range(tCapital[1] - 1, tCapital[1] + 2):	# from y-1 to y+1
                                        pCurrent=gc.getMap().plot(x, y)
                                        pCurrent.setCulture(iCiv, 200, True)
                                        pCurrent.setOwner(iCiv)
                        self.setDeleteMode(-1)
                        return
                    
                if (iCurrentPlayer != iCiv-1):
                        return
                
                bNotOwned = True
                for x in range(tCapital[0] - 1, tCapital[0] + 2):        # from x-1 to x+1
                        for y in range(tCapital[1] - 1, tCapital[1] + 2):	# from y-1 to y+1
                                #print ("deleting again", x, y)
                                pCurrent=gc.getMap().plot(x, y)
                                if (pCurrent.isOwned()):
                                        bNotOwned = False
                                        for iLoopCiv in range(iNumTotalPlayers+1): #Barbarians as well
                                                pCurrent.setCulture(iLoopCiv, 0, True)
                                        pCurrent.setOwner(-1)
                
                for x in range(tCapital[0] - 1, tCapital[0] + 2):        # from x-1 to x+1
                        for y in range(tCapital[1] - 1, tCapital[1] + 2):
                                #print ("units", x, y, gc.getMap().plot(x, y).getNumUnits(), tCapital[0], tCapital[1])
                                if (x != tCapital[0] or y != tCapital[1]):
                                        pCurrent=gc.getMap().plot(x, y)
                                        if (pCurrent.getNumUnits() > 0):
                                                unit = pCurrent.getUnit(0)
                                                #print ("units2", x, y, gc.getMap().plot(x, y).getNumUnits(), unit.getOwner(), iCiv)
                                                if (unit.getOwner() == iCiv):
                                                        for i in range(pCurrent.getNumUnits()):
                                                                print ("moving starting units to", (tCapital[0], tCapital[1]))
                                                                unit = pCurrent.getUnit(0)
                                                                unit.setXY(tCapital[0], tCapital[1])

                


            
                    
        def birthInFreeRegion(self, iCiv, tCapital, tTopLeft, tBottomRight):
                startingPlot = gc.getMap().plot( tCapital[0], tCapital[1] )
                if (self.getFlipsDelay(iCiv) == 0):
                        if (startingPlot.getNumUnits() > 0):
                                unit = startingPlot.getUnit(0)
                                if (unit.getOwner() != utils.getHumanID()):
                                        for i in range(startingPlot.getNumUnits()):
                                                unit = startingPlot.getUnit(0)	# 0 instead of i because killing units changes the indices
                                                unit.kill(False, iCiv)
                                        iFlipsDelay = self.getFlipsDelay(iCiv) + 2
                                        #utils.debugTextPopup( 'birthInFreeRegion in starting location' ) 
                                else:   #search another place
                                        dummy, plotList = utils.squareSearch( tTopLeft, tBottomRight, utils.goodPlots, [] )
                                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching another free plot')
                                        if (len(plotList)):
                                                result = plotList[rndNum]
                                                if (result):
                                                        self.createStartingUnits(iCiv, result)
                                                        tCapital = result
                                                        #utils.debugTextPopup( 'birthInFreeRegion in another location' )
                                                        iFlipsDelay = self.getFlipsDelay(iCiv) + 1 #add delay before flipping other cities
                                        else: 
                                                if (self.getSpawnDelay(iCiv) < 10):  #wait
                                                        iSpawnDelay = self.getSpawnDelay(iCiv) + 1
                                                        self.setSpawnDelay(iCiv, iSpawnDelay)                                                        
                        else:
                                iFlipsDelay = self.getFlipsDelay(iCiv) + 2

                        if (iFlipsDelay > 0):
                                #startingPlot.setImprovementType(-1)
                            
                                #gc.getPlayer(iCiv).found(tCapital[0], tCapital[1])
                                #gc.getMap().plot(tCapital[0], tCapital[1]).setRevealed(iCiv, False, True, -1);
                                #gc.getMap().plot(tCapital[0], tCapital[1]).setRevealed(iCiv, True, True, -1);
                                
                                print ("starting units in", tCapital[0], tCapital[1])
                                self.createStartingUnits(iCiv, (tCapital[0], tCapital[1]))
##                                settlerPlot = gc.getMap().plot( tCapital[0], tCapital[1] )
##                                for i in range(settlerPlot.getNumUnits()):
##                                        unit = settlerPlot.getUnit(i)
##                                        if (unit.getUnitType() == iSettler):
##                                                break
##                                unit.found()                                
                                utils.flipUnitsInArea((tCapital[0]-2, tCapital[1]-2), (tCapital[0]+2, tCapital[1]+2), iCiv, iBarbarian, True, True) #This is for AI only. During Human player spawn, that area is already cleaned                        
                                utils.flipUnitsInArea((tCapital[0]-2, tCapital[1]-2), (tCapital[0]+2, tCapital[1]+2), iCiv, iIndependent, True, False) #This is for AI only. During Human player spawn, that area is already cleaned                        
                                utils.flipUnitsInArea((tCapital[0]-2, tCapital[1]-2), (tCapital[0]+2, tCapital[1]+2), iCiv, iIndependent2, True, False) #This is for AI only. During Human player spawn, that area is already cleaned                        
                                self.assignTechs(iCiv)
                                utils.setPlagueCountdown(iCiv, -con.iImmunity) 
                                #gc.getPlayer(iCiv).changeAnarchyTurns(1)
                                #gc.getPlayer(iCiv).setCivics(2, 11)
                                self.setFlipsDelay(iCiv, iFlipsDelay) #save
                                

                else: #starting units have already been placed, now the second part                    
                        iNumAICitiesConverted, iNumHumanCitiesToConvert = self.convertSurroundingCities(iCiv, tTopLeft, tBottomRight)
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iBarbarian, False, True) #remaining barbs in the region now belong to the new civ   
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iIndependent, False, False) #remaining independents in the region now belong to the new civ   
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iIndependent2, False, False) #remaining independents in the region now belong to the new civ   
                        print ("utils.flipUnitsInArea()") 
                        #cover plots revealed by the lion
                        plotZero = gc.getMap().plot( 0, 0 )                        
                        if (plotZero.getNumUnits()):
                                catapult = plotZero.getUnit(0)
                                catapult.kill(False, iCiv)
                        gc.getMap().plot(0, 0).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(0, 1).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(1, 1).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(1, 0).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(123, 0).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(123, 1).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(2, 0).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(2, 1).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(2, 2).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(1, 2).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(0, 2).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(122, 0).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(122, 1).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(122, 2).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(123, 2).setRevealed(iCiv, False, True, -1);
                        print ("Plots covered")

                        if (gc.getPlayer(iCiv).getNumCities() > 0):
                                capital = gc.getPlayer(iCiv).getCapitalCity()
                                self.createStartingWorkers(iCiv, (capital.getX(), capital.getY()))

                        if (iNumHumanCitiesToConvert> 0):
                                self.flipPopup(iCiv, tTopLeft, tBottomRight)

                        
        def birthInForeignBorders(self, iCiv, tTopLeft, tBottomRight, tBroaderTopLeft, tBroaderBottomRight):
                
                iNumAICitiesConverted, iNumHumanCitiesToConvert = self.convertSurroundingCities(iCiv, tTopLeft, tBottomRight)

                #now starting units must be placed
                if (iNumAICitiesConverted > 0):
                        #utils.debugTextPopup( 'iConverted OK for placing units' )
                        dummy1, plotList = utils.squareSearch( tTopLeft, tBottomRight, utils.ownedCityPlots, iCiv )        
                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching any city just flipped')
                        #print ("rndNum for starting units", rndNum)
                        if (len(plotList)):
                                result = plotList[rndNum]
                                if (result):
                                        self.createStartingUnits(iCiv, result)
                                        #utils.debugTextPopup( 'birthInForeignBorders after a flip' )
                                        self.assignTechs(iCiv)
                                        utils.setPlagueCountdown(iCiv, -con.iImmunity)
                                        #gc.getPlayer(iCiv).changeAnarchyTurns(1)
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iBarbarian, False, True) #remaining barbs in the region now belong to the new civ 
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iIndependent, False, False) #remaining barbs in the region now belong to the new civ 
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iIndependent2, False, False) #remaining barbs in the region now belong to the new civ 
                        
                else:   #search another place
                        dummy, plotList = utils.squareSearch( tTopLeft, tBottomRight, utils.goodPlots, [] )
                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching another free plot')
                        if (len(plotList)):
                                result = plotList[rndNum]
                                if (result):
                                        self.createStartingUnits(iCiv, result)
                                        #utils.debugTextPopup( 'birthInForeignBorders in another location' )
                                        self.assignTechs(iCiv)
                                        utils.setPlagueCountdown(iCiv, -con.iImmunity)
                        else:
                                dummy1, plotList = utils.squareSearch( tBroaderTopLeft, tBroaderBottomRight, utils.goodPlots, [] )        
                                rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching other good plots in a broader region')
                                if (len(plotList)):
                                        result = plotList[rndNum]
                                        if (result):
                                                self.createStartingUnits(iCiv, result)
                                                self.createStartingWorkers(iCiv, result)
                                                #utils.debugTextPopup( 'birthInForeignBorders in a broader area' )
                                                self.assignTechs(iCiv)
                                                utils.setPlagueCountdown(iCiv, -con.iImmunity)
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iBarbarian, True, True) #remaining barbs in the region now belong to the new civ 
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iIndependent, True, False) #remaining barbs in the region now belong to the new civ 
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iIndependent2, True, False) #remaining barbs in the region now belong to the new civ 

                if (iNumHumanCitiesToConvert> 0):
                        self.flipPopup(iCiv, tTopLeft, tBottomRight)




                                                
        def convertSurroundingCities(self, iCiv, tTopLeft, tBottomRight):
                iConvertedCitiesCount = 0
                iNumHumanCities = 0
                cityList = []
                self.setSpawnWar(0)
                
                #collect all the cities in the spawn region
                for x in range(tTopLeft[0], tBottomRight[0]+1):
                        for y in range(tTopLeft[1], tBottomRight[1]+1):
                                pCurrent = gc.getMap().plot( x, y )
                                if ( pCurrent.isCity()):
                                        if (pCurrent.getPlotCity().getOwner() != iCiv):
                                                cityList.append(pCurrent.getPlotCity())

                #Exceptions
                if (len(tExceptions[iCiv])):
                        for j in range(len(tExceptions[iCiv])):
                                pCurrent = gc.getMap().plot( tExceptions[iCiv][j][0], tExceptions[iCiv][j][1] )
                                if ( pCurrent.isCity()):
                                        if (pCurrent.getPlotCity().getOwner() != iCiv):
                                                print ("append", pCurrent)
                                                cityList.append(pCurrent.getPlotCity())

                print ("Birth", iCiv)
                #print (cityList)

                #for each city
                if (len(cityList)):
                        for i in range(len(cityList)):
                                print ("cityList", cityList[i].getName(), (cityList[i].getX(),cityList[i].getY()))
                                iHuman = utils.getHumanID()
                                iOwner = cityList[i].getOwner()
                                iCultureChange = 0 #if 0, no flip; if > 0, flip will occur with the value as variable for utils.CultureManager()
                                
                                #case 1: barbarian/independent city
                                if (iOwner == iBarbarian or iOwner == iIndependent or iOwner == iIndependent2 or iOwner == iCeltia):
                                        #utils.debugTextPopup( 'BARB' )
                                        iCultureChange = 100
                                #case 2: human city
                                elif (iOwner == iHuman and not cityList[i].isCapital()):
                                        #utils.debugTextPopup( 'HUMAN' )
        ##                                bForeigners = False
        ##                                cityPlot = gc.getMap().plot(cityList[i].getX(), cityList[i].getY())
        ##                                cityCulture = cityList[i].countTotalCulture()
        ##                                iCultureThreshold = 10
        ##                                for j in range(iNumPlayers+1):
        ##                                        if (cityList[i].getCulture(j)*100 / cityCulture >= iCultureThreshold) and (j != iHuman):
        ##                                                bForeigners = True
        ##                                humanCapital = gc.getPlayer(iHuman).getCapitalCity()
        ##                                iDistance = gc.getMap().calculatePathDistance(cityPlot, gc.getMap().plot(humanCapital.getX(),humanCapital.getY()))
        ##                                if (cityList[i].isOccupation()) or (cityList[i].isDisorder()) or (bForeigners == True) or (not cityPlot.getNumUnits()) or ((not cityList[i].isGovernmentCenter()) and (iDistance >= 8) and (gc.getPlayer(iHuman).getNumCities() >= 5)):
                                        if (iNumHumanCities == 0):
                                                iNumHumanCities += 1
                                                #iConvertedCitiesCount += 1
                                                #self.flipPopup(iCiv, tTopLeft, tBottomRight)
                                #case 3: other
                                elif (not cityList[i].isCapital()):   #utils.debugTextPopup( 'OTHER' )                                
                                        if (iConvertedCitiesCount < 6): #there won't be more than 5 flips in the area
                                                #utils.debugTextPopup( 'iConvertedCities OK' )
                                                iCultureChange = 50
                                                if (gc.getGame().getGameTurn() <= con.tBirth[iCiv] + 5): #if we're during a birth
                                                        rndNum = gc.getGame().getSorenRandNum(100, 'odds')
                                                        if (rndNum >= tAIStopBirthThreshold[iOwner]):
                                                                print (iOwner, "stops birth", iCiv, "rndNum:", rndNum, "threshold:", tAIStopBirthThreshold[iOwner])
                                                                if (not gc.getTeam(gc.getPlayer(iOwner).getTeam()).isAtWar(iCiv)):                                                                        
                                                                        gc.getTeam(gc.getPlayer(iOwner).getTeam()).declareWar(iCiv, False)
                                                                        if (gc.getPlayer(iCiv).getNumCities() > 0): #this check is needed, otherwise game crashes
                                                                                print ("capital:", gc.getPlayer(iCiv).getCapitalCity().getX(), gc.getPlayer(iCiv).getCapitalCity().getY())
                                                                                if (gc.getPlayer(iCiv).getCapitalCity().getX() != -1 and gc.getPlayer(iCiv).getCapitalCity().getY() != -1):
                                                                                        self.createAdditionalUnits(iCiv, (gc.getPlayer(iCiv).getCapitalCity().getX(), gc.getPlayer(iCiv).getCapitalCity().getY()))
                                                                                else:
                                                                                        self.createAdditionalUnits(iCiv, tCapitals[iCiv])
                                                                        
                                                        

                                if (iCultureChange > 0):
                                        #print ("flipping ", cityList[i].getName())
                                        utils.cultureManager((cityList[i].getX(),cityList[i].getY()), iCultureChange, iCiv, iOwner, True, False, False)
                                        #gc.getMap().plot(cityList[i].getX(),cityList[i].getY()).setImprovementType(-1)
                                        
                                        utils.flipUnitsInCityBefore((cityList[i].getX(),cityList[i].getY()), iCiv, iOwner)
                                        self.setTempFlippingCity((cityList[i].getX(),cityList[i].getY())) #necessary for the (688379128, 0) bug
                                        utils.flipCity((cityList[i].getX(),cityList[i].getY()), 0, 0, iCiv, [iOwner])                                                
                                        #print ("cityList[i].getXY", cityList[i].getX(), cityList[i].getY()) 
                                        utils.flipUnitsInCityAfter(self.getTempFlippingCity(), iCiv)
                                        
                                        iConvertedCitiesCount += 1
                                        print ("iConvertedCitiesCount", iConvertedCitiesCount)

                #print( "converted cities", iConvertedCitiesCount)
                return (iConvertedCitiesCount, iNumHumanCities)



        def minorBirth(self, iCurrentTurn, iCiv, tCapital, name, iPopulation):
                iBirthYear = tBirth[iCiv]
                iHuman = utils.getHumanID()
                pCiv = gc.getPlayer(iCiv)
                bRoomFound = False
                #if (iCurrentTurn > 0 and iCiv == iPortugal): #debug
                if (iCurrentTurn == iBirthYear-1): #-1
                        tTopLeft = tCoreAreasTL[iCiv]
                        tBottomRight = tCoreAreasBR[iCiv]
                        for x in range(tTopLeft[0], tBottomRight[0] + 1):
                                for y in range(tTopLeft[1], tBottomRight[1] + 1):
                                        pCurrent=gc.getMap().plot(x, y)
                                        #print ("pCurrent", x, y)
                                        for iLoopCiv in range(iNumTotalPlayers+1): #Barbarians as well
                                                if (iLoopCiv != iCiv):
                                                        oldCulture = pCurrent.getCulture(iLoopCiv)
                                                        pCurrent.setCulture(iLoopCiv, 0, True)
                                                        pCurrent.changeCulture(iCiv, oldCulture, True)
                                                        #print (iLoopCiv, oldCulture)
                        bCityInArea = False                        
                        for x in range(tCapital[0] - 1, tCapital[0] + 2):        # from x-1 to x+1
                                for y in range(tCapital[1] - 1, tCapital[1] + 2):	# from y-1 to y+1
                                        pCurrent=gc.getMap().plot(x, y)
                                        if (pCurrent.isCity()):
                                                bCityInArea = True
                        if (not bCityInArea):
                                bRoomFound = True
                                gc.getMap().plot(tCapital[0], tCapital[1]).eraseAIDevelopment()
                                gc.getMap().plot(tCapital[0], tCapital[1]).setOwner(-1)
                                for x in range(tCapital[0] - 1, tCapital[0] + 2):      
                                        for y in range(tCapital[1] - 1, tCapital[1] + 2):
                                                pCurrent=gc.getMap().plot(x, y)
                                                pCurrent.setOwner(-1)
                        else:
                                bDeleteEverything = True
                                for x in range(tCapital[0] - 1, tCapital[0] + 2):      
                                        for y in range(tCapital[1] - 1, tCapital[1] + 2):
                                                pCurrent=gc.getMap().plot(x, y)
                                                if (pCurrent.isVisible(iHuman, False)):
                                                        bDeleteEverything = False
                                if (bDeleteEverything):
                                        for x in range(tCapital[0] - 1, tCapital[0] + 2):      
                                                for y in range(tCapital[1] - 1, tCapital[1] + 2):
                                                        pCurrent=gc.getMap().plot(x, y)
                                                        pCurrent.eraseAIDevelopment()
                                                        pCurrent.setOwner(-1)
                                        bRoomFound = True
                        print ("bRoomFound", bRoomFound, tCapital)
                        if (bRoomFound):
                                self.createStartingUnits(iCiv, tCapital)
                                pCiv.found(tCapital[0], tCapital[1])
                                CyGlobalContext().getMap().plot(tCapital[0], tCapital[1]).getPlotCity().setName(name, False)
                                CyGlobalContext().getMap().plot(tCapital[0], tCapital[1]).getPlotCity().setPopulation(iPopulation)
                                for x in range(tCapital[0] - 1, tCapital[0] + 2):      
                                        for y in range(tCapital[1] - 1, tCapital[1] + 2):
                                                pCurrent=gc.getMap().plot(x, y)
                                                pCurrent.changeCulture(iCiv, 100, True)
                                            
                                self.assignTechs(iCiv)
                                utils.setPlagueCountdown(iCiv, -con.iImmunity)
                                for iLoopCiv in range( iNumActivePlayers ):
                                        if (iLoopCiv != iCiv and iLoopCiv != iHuman):
                                                gc.getTeam(gc.getPlayer(iCiv).getTeam()).signOpenBorders(iLoopCiv)

                                #convert surrounding cities
                                for x in range(tTopLeft[0], tBottomRight[0] + 1):        # from x-1 to x+1
                                        for y in range(tTopLeft[1], tBottomRight[1] + 1):	# from y-1 to y+1
                                                pCurrent=gc.getMap().plot(x, y)
                                                if (pCurrent.isCity()):
                                                        city = pCurrent.getPlotCity()
                                                        iOwner = city.getOwner()
                                                        if (iOwner != iCiv):                                                
                                                                utils.flipUnitsInCityBefore((x,y), iCiv, iOwner)
                                                                self.setTempFlippingCity((x,y)) #necessary for the (688379128, 0) bug
                                                                utils.flipCity((x,y), 0, 0, iCiv, [iOwner])                                                
                                                                utils.flipUnitsInCityAfter(self.getTempFlippingCity(), iCiv)
                                return True
                        else:
                                return False
                                



        def findSeaPlots( self, tCoords):
                """Searches a sea plot that isn't occupied by a unit and isn't a civ's territory surrounding the starting coordinates"""
                seaPlotList = []
                for x in range(tCoords[0] - 1, tCoords[0] + 2):        # from x-1 to x+1
                        for y in range(tCoords[1] - 1, tCoords[1] + 2):	# from y-1 to y+1
                                pCurrent = gc.getMap().plot( x, y )
                                if ( pCurrent.isWater()):
                                        if ( not pCurrent.isUnit() ):
                                                if (pCurrent.countTotalCulture() == 0 ):
                                                        seaPlotList.append(pCurrent)
                                                        # this is a good plot, so paint it and continue search
                if (len(seaPlotList) > 0):
                        rndNum = gc.getGame().getSorenRandNum(len(seaPlotList), 'sea plot')
                        result = seaPlotList[rndNum]
                        if (result):                                                        
                                    return ((result.getX(), result.getY()))
                return (None)


        def giveColonists( self, iCiv, tBroaderAreaTL, tBroaderAreaBR):
                pCiv = gc.getPlayer(iCiv)
                teamCiv = gc.getTeam(pCiv.getTeam())
                if (teamCiv.isHasTech(con.iAstronomy)) and (self.getColonistsAlreadyGiven(iCiv) <= 6) and (pCiv.isAlive()) and (pCiv.isHuman() == False):
                        print ("Astronomy")
                        cityList = []
                        #collect all the coastal cities belonging to iCiv in the area
                        for x in range(tBroaderAreaTL[0], tBroaderAreaBR[0]+1):
                                for y in range(tBroaderAreaTL[1], tBroaderAreaBR[1]+1):
                                        pCurrent = gc.getMap().plot( x, y )
                                        if ( pCurrent.isCity()):
                                                city = pCurrent.getPlotCity()
                                                if (city.getOwner() == iCiv):
                                                        if (city.isCoastalOld()):
                                                                cityList.append(city)                                                        
                        if (len(cityList)):
                                result = cityList[0]
##                                for loopCity in cityList:
##                                        if (loopCity.getX() < result.getX() and \
##                                            loopCity.getX() >= tNormalAreasTL[iCiv][0] and \
##                                            loopCity.getX() <= tNormalAreasBR[iCiv][0] and \
##                                            loopCity.getY() >= tNormalAreasTL[iCiv][1] and \
##                                            loopCity.getY() <= tNormalAreasBR[iCiv][1]):
##                                                result = loopCity
                                rndNum = gc.getGame().getSorenRandNum(len(cityList), 'random city')
                                result = cityList[rndNum]
                                if (result):
                                        tPlot = (result.getX(), result.getY())
                                        utils.makeUnit(con.iSettler, iCiv, tPlot, 1)
                                        if (rndNum % 2 == 0):
                                                utils.makeUnit(con.iPikeman, iCiv, tPlot, 1)
                                        else:
                                                utils.makeUnit(con.iWorker, iCiv, tPlot, 1)
                                        if (teamCiv.isHasTech(con.iGunpowder)):
                                                utils.makeUnit(con.iMusketman, iCiv, tPlot, 1)
                                        else:
                                                if (iCiv == iSpain):
                                                        if (teamSpain.isHasTech(con.iGuilds)):
                                                                utils.makeUnit(con.iConquistador, iCiv, tPlot, 1)
                                                        else:
                                                                utils.makeUnit(con.iLongbowman, iCiv, tPlot, 1)
                                                else:
                                                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 1)
                                        gc.getPlayer(iCiv).initUnit(con.iGalleon, tPlot[0], tPlot[1], UnitAITypes.UNITAI_SETTLER_SEA)
                                        iColonistsAlreadyGiven = self.getColonistsAlreadyGiven(iCiv) + 1
                                        self.setColonistsAlreadyGiven(iCiv, iColonistsAlreadyGiven)
                                        print iCiv

                #part2: upgrade galleys to galleons, just once
                if (gc.getTeam(pCiv.getTeam()).isHasTech(con.iAstronomy)) and (self.getColonistsAlreadyGiven(iCiv) == 0) and (pCiv.isAlive()) and (pCiv.isHuman() == False):
                        for x in range(0, 123+1):
                                for y in range(0, 67+1):
                                        killPlot = gc.getMap().plot(x,y)
                                        iNumUnitsInAPlot = killPlot.getNumUnits()
                                        if (iNumUnitsInAPlot):  
                                                for i in range(iNumUnitsInAPlot):                                                
                                                        unit = killPlot.getUnit(i)
                                                        if (unit.getOwner() == iCiv):
                                                                if (unit.getUnitType() == iGalley):
                                                                        unit.kill(False, iBarbarian)
                                                                        gc.getPlayer(iCiv).initUnit(iGalleon, x, y, UnitAITypes.UNITAI_SETTLER_SEA)
                                                                        i = i - 1
                          


        def initMinorBetrayal( self, iCiv ):
                iHuman = utils.getHumanID()
                dummy, plotList = utils.squareSearch( tCoreAreasTL[iCiv], tCoreAreasBR[iCiv], utils.outerInvasion, [] )
                rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching a free plot abroad human players borders')
                if (len(plotList)):
                        result = plotList[rndNum]
                        if (result):
                                self.createAdditionalUnits(iCiv, result)
                                self.unitsBetrayal(iCiv, iHuman, tCoreAreasTL[iCiv], tCoreAreasBR[iCiv], result)



        def initBetrayal( self ):
                iHuman = utils.getHumanID()
                turnsLeft = self.getBetrayalTurns()
                dummy, plotList = utils.squareSearch( self.getTempTopLeft(), self.getTempBottomRight(), utils.outerInvasion, [] )
                rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching a free plot abroad human players borders')
                if (not len(plotList)):
                        dummy, plotList = utils.squareSearch( self.getTempTopLeft(), self.getTempBottomRight(), utils.innerInvasion, [iHuman, self.getNewCivFlip()] )
                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching a free plot within human or new civs border but distant from units')                                
                if (not len(plotList)):
                        dummy, plotList = utils.squareSearch( self.getTempTopLeft(), self.getTempBottomRight(), utils.innerInvasion, [iHuman, self.getNewCivFlip()] )
                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching a free plot within human or new civs border')                                
                if (len(plotList)):
                        result = plotList[rndNum]
                        if (result):
                                if (turnsLeft == iBetrayalPeriod):
                                        self.createAdditionalUnits(self.getNewCivFlip(), result)
                                self.unitsBetrayal(self.getNewCivFlip(), iHuman, self.getTempTopLeft(), self.getTempBottomRight(), result)
                self.setBetrayalTurns(turnsLeft - 1)



        def unitsBetrayal( self, iNewOwner, iOldOwner, tTopLeft, tBottomRight, tPlot ):
                #print ("iNewOwner", iNewOwner, "iOldOwner", iOldOwner, "tPlot", tPlot)
                CyInterface().addImmediateMessage(CyTranslator().getText("TXT_KEY_FLIP_BETRAYAL", ()), "")
                for x in range(tTopLeft[0], tBottomRight[0]+1):
                        for y in range(tTopLeft[1], tBottomRight[1]+1):
                                killPlot = gc.getMap().plot(x,y)
                                iNumUnitsInAPlot = killPlot.getNumUnits()
                                if (iNumUnitsInAPlot):                                                                  
                                        for i in range(iNumUnitsInAPlot):                                                
                                                unit = killPlot.getUnit(i)
                                                if (unit.getOwner() == iOldOwner):
                                                        rndNum = gc.getGame().getSorenRandNum(100, 'betrayal')
                                                        if (rndNum >= iBetrayalThreshold):
                                                                if (unit.getDomainType() == 2): #land unit
                                                                        unit.kill(False, iNewOwner)
                                                                        utils.makeUnit(unit.getUnitType(), iNewOwner, tPlot, 1)
                                                                        i = i - 1



        def createAdditionalUnits( self, iCiv, tPlot ):
                if (iCiv == iGreece):
                        utils.makeUnit(con.iGreekPhalanx, iCiv, tPlot, 4)
                if (iCiv == iPersia):
                        utils.makeUnit(con.iPersiaImmortal, iCiv, tPlot, 4)
                if (iCiv == iCarthage):
                        utils.makeUnit(con.iCarthageNumidianCavalry, iCiv, tPlot, 4)
                if (iCiv == iRome):
                        utils.makeUnit(con.iRomePraetorian, iCiv, tPlot, 4)
                if (iCiv == iJapan):
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 2)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                if (iCiv == iVikings):
                        utils.makeUnit(con.iAxeman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                if (iCiv == iArabia):
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iArabiaCamelarcher, iCiv, tPlot, 4)
                if (iCiv == iFrance):
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 3)
                if (iCiv == iSpain):
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 3)
                if (iCiv == iEngland):
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 3)
                if (iCiv == iGermany):                        
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 3)
                if (iCiv == iRussia):
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iHorseArcher, iCiv, tPlot, 2)                 
                if (iCiv == iMali):
                        utils.makeUnit(con.iMaliSkirmisher, iCiv, tPlot, 4)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 3)
                if (iCiv == iTurkey):
                        utils.makeUnit(con.iCrossbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iHorseArcher, iCiv, tPlot, 3)   
                if (iCiv == iInca):
                        utils.makeUnit(con.iIncanQuechua, iCiv, tPlot, 5)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 3)
                if (iCiv == iMongolia):
                        utils.makeUnit(con.iCrossbowman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iHorseArcher, iCiv, tPlot, 2) 
                        utils.makeUnit(con.iMongolKeshik, iCiv, tPlot, 4)
                if (iCiv == iAztecs):
                        utils.makeUnit(con.iAztecJaguar, iCiv, tPlot, 5)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 3)
                if (iCiv == iAmerica):
                        utils.makeUnit(con.iPikeman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iMusketman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iCannon, iCiv, tPlot, 3)


        def createStartingUnits( self, iCiv, tPlot ):
                if (iCiv == iGreece):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 1)
                        utils.makeUnit(con.iWarrior, iCiv, tPlot, 2)
                        utils.makeUnit(con.iGreekPhalanx, iCiv, tPlot, 3)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 1)
                if (iCiv == iPersia):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 2)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 5)
                        utils.makeUnit(con.iPersiaImmortal, iCiv, tPlot, 7)
                if (iCiv == iCarthage):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 1)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 3)
                        utils.makeUnit(con.iCarthageNumidianCavalry, iCiv, tPlot, 3)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):                                
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 2)
                                pCarthage.initUnit(con.iGalley, tSeaPlot[0], tSeaPlot[1], UnitAITypes.UNITAI_SETTLER_SEA)
                                utils.makeUnit(con.iSettler, iCiv, tSeaPlot, 1)
                                pCarthage.initUnit(con.iGalley, tSeaPlot[0], tSeaPlot[1], UnitAITypes.UNITAI_ASSAULT_SEA)
                                pCarthage.initUnit(con.iTrireme, tSeaPlot[0], tSeaPlot[1], UnitAITypes.UNITAI_ESCORT_SEA)
                if (iCiv == iRome):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 1)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 3)
                        utils.makeUnit(con.iRomePraetorian, iCiv, tPlot, 4)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):                                
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 1)
                                pRome.initUnit(con.iGalley, tSeaPlot[0], tSeaPlot[1], UnitAITypes.UNITAI_ASSAULT_SEA)
                                pRome.initUnit(con.iGalley, tSeaPlot[0], tSeaPlot[1], UnitAITypes.UNITAI_ASSAULT_SEA)
                if (iCiv == iJapan):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 2)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 2)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):                                
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 2)
                if (iCiv == iVikings):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 3)
                        utils.makeUnit(con.iAxeman, iCiv, tPlot, 1)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):                                
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 1)
                                pVikings.initUnit(con.iGalley, tSeaPlot[0], tSeaPlot[1], UnitAITypes.UNITAI_ASSAULT_SEA)
                                utils.makeUnit(con.iAxeman, iCiv, tSeaPlot, 2)
                                pVikings.initUnit(con.iGalley, tSeaPlot[0], tSeaPlot[1], UnitAITypes.UNITAI_SETTLER_SEA)                                
                if (iCiv == iArabia):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 4)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iArabiaCamelarcher, iCiv, tPlot, 5)
                if (iCiv == iFrance):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 2)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iAxeman, iCiv, tPlot, 2)
                if (iCiv == iSpain):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 4)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                if (iCiv == iEngland):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 4)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 4)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):                                
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 2)
                                utils.makeUnit(con.iGalley, iCiv, tSeaPlot, 2)
                                pEngland.initUnit(con.iGalley, tSeaPlot[0], tSeaPlot[1], UnitAITypes.UNITAI_SETTLER_SEA)
                if (iCiv == iGermany):                        
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iAxeman, iCiv, tPlot, 3)
                if (iCiv == iRussia):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 4)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iHorseArcher, iCiv, tPlot, 3)                 
                if (iCiv == iMali):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iMaliSkirmisher, iCiv, tPlot, 5)
                if (iCiv == iTurkey):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 1)
                        utils.makeUnit(con.iCrossbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iHorseArcher, iCiv, tPlot, 3)
                        utils.makeUnit(con.iCatapult, iCiv, tPlot, 3)
                        utils.makeUnit(con.iTrebuchet, iCiv, tPlot, 3) 
                if (iCiv == iInca):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 4)
                        utils.makeUnit(con.iScout, iCiv, tPlot, 2)
                        utils.makeUnit(con.iIncanQuechua, iCiv, tPlot, 4)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 3)
                if (iCiv == iMongolia):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 5)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 1)
                        utils.makeUnit(con.iCrossbowman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iHorseArcher, iCiv, tPlot, 2) 
                        utils.makeUnit(con.iMongolKeshik, iCiv, tPlot, 6)
                if (iCiv == iAztecs):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iAztecJaguar, iCiv, tPlot, 4)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 4)
                if (iCiv == iAmerica):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 5)
                        utils.makeUnit(con.iGrenadier, iCiv, tPlot, 2)
                        utils.makeUnit(con.iRifleman, iCiv, tPlot, 4)
                        utils.makeUnit(con.iCannon, iCiv, tPlot, 2)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):  
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 2)
                                utils.makeUnit(con.iGalleon, iCiv, tSeaPlot, 2)
                                utils.makeUnit(con.iFrigate, iCiv, tSeaPlot, 1)
##                if (iCiv == iHolland):                        
##                        utils.makeUnit(con.iCrossbowman, iCiv, tPlot, 3)
##                        utils.makeUnit(con.iPikeman, iCiv, tPlot, 3)
##                if (iCiv == iPortugal):
##                        utils.makeUnit(con.iCrossbowman, iCiv, tPlot, 3)
##                        utils.makeUnit(con.iPikeman, iCiv, tPlot, 3)

                                
        def createStartingWorkers( self, iCiv, tPlot ):
                if (iCiv == iGreece):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 2)
                if (iCiv == iPersia):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 2)
                if (iCiv == iCarthage):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 2)
                if (iCiv == iRome):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 2)
                if (iCiv == iJapan):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 2)
                if (iCiv == iVikings):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)                              
                if (iCiv == iArabia):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)
                if (iCiv == iFrance):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)
                if (iCiv == iSpain):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)
                if (iCiv == iEngland):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)
                if (iCiv == iGermany):                        
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)
                if (iCiv == iRussia):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)               
                if (iCiv == iMali):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)
                if (iCiv == iTurkey):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 4)
                if (iCiv == iInca):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 4)
                if (iCiv == iMongolia):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 4)
                if (iCiv == iAztecs):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)
                if (iCiv == iAmerica):
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 4)
                        

        def create4000BCstartingUnits( self ):

                utils.makeUnit(iSettler, iEgypt, tCapitals[iEgypt], 1)
                utils.makeUnit(iWarrior, iEgypt, tCapitals[iEgypt], 1)

                utils.makeUnit(iSettler, iIndia, tCapitals[iIndia], 1)
                utils.makeUnit(iWarrior, iIndia, tCapitals[iIndia], 1)

                utils.makeUnit(iSettler, iChina, tCapitals[iChina], 1)
                utils.makeUnit(iWarrior, iChina, tCapitals[iChina], 1)

                utils.makeUnit(iSettler, iBabylonia, tCapitals[iBabylonia], 1)
                utils.makeUnit(iWarrior, iBabylonia, tCapitals[iBabylonia], 1)

                if ( pGreece.isHuman() ):
                    utils.makeUnit(iSettler, iGreece, tCapitals[iGreece], 1)
                    utils.makeUnit(iScout, iGreece, tCapitals[iGreece], 1)
                if ( pPersia.isHuman() ):
                    utils.makeUnit(iSettler, iPersia, tCapitals[iPersia], 1)
                    utils.makeUnit(iScout, iPersia, tCapitals[iPersia], 1)
                if ( pCarthage.isHuman() ):
                    utils.makeUnit(iSettler, iCarthage, tCapitals[iCarthage], 1)
                    utils.makeUnit(iScout, iCarthage, tCapitals[iCarthage], 1)
                if ( pRome.isHuman() ):
                    utils.makeUnit(iSettler, iRome, tCapitals[iRome], 1)
                    utils.makeUnit(iWarrior, iRome, tCapitals[iRome], 1)
                if ( pJapan.isHuman() ):
                    utils.makeUnit(iSettler, iJapan, tCapitals[iJapan], 1)
                    utils.makeUnit(iWarrior, iJapan, tCapitals[iJapan], 1)
                if ( pVikings.isHuman() ):
                    utils.makeUnit(iSettler, iVikings, tCapitals[iVikings], 1)
                    utils.makeUnit(iScout, iVikings, tCapitals[iVikings], 1)
                if ( pArabia.isHuman() ):
                    utils.makeUnit(con.iSettler, iArabia, tCapitals[iArabia], 1)
                    utils.makeUnit(con.iWarrior, iArabia, tCapitals[iArabia], 1)
                if ( pSpain.isHuman() ):
                    utils.makeUnit(iSettler, iSpain, tCapitals[iSpain], 1)
                    utils.makeUnit(iWarrior, iSpain, tCapitals[iSpain], 1)
                if ( pFrance.isHuman() ):
                    utils.makeUnit(iSettler, iFrance, tCapitals[iFrance], 1)
                    utils.makeUnit(iWarrior, iFrance, tCapitals[iFrance], 1)
                if ( pEngland.isHuman() ):
                    utils.makeUnit(iSettler, iEngland, tCapitals[iEngland], 1)
                    utils.makeUnit(iWarrior, iEngland, tCapitals[iEngland], 1)
                if ( pGermany.isHuman() ):
                    utils.makeUnit(iSettler, iGermany, tCapitals[iGermany], 1)
                    utils.makeUnit(iScout, iGermany, tCapitals[iGermany], 1)
                if ( pRussia.isHuman() ):
                    utils.makeUnit(iSettler, iRussia, tCapitals[iRussia], 1)
                    utils.makeUnit(iScout, iRussia, tCapitals[iRussia], 1)
                if ( pMali.isHuman() ):
                    utils.makeUnit(iSettler, iMali, tCapitals[iMali], 1)
                    utils.makeUnit(iWarrior, iMali, tCapitals[iMali], 1)
                if ( pTurkey.isHuman() ):
                    utils.makeUnit(iSettler, iTurkey, tCapitals[iTurkey], 1)
                    utils.makeUnit(iWarrior, iTurkey, tCapitals[iTurkey], 1)
                if ( pInca.isHuman() ):
                    utils.makeUnit(iSettler, iInca, tCapitals[iInca], 1)
                    utils.makeUnit(iWarrior, iInca, tCapitals[iInca], 1)
                if ( pMongolia.isHuman() ):
                    utils.makeUnit(iSettler, iMongolia, tCapitals[iMongolia], 1)
                    utils.makeUnit(iScout, iMongolia, tCapitals[iMongolia], 1)
                if ( pAztecs.isHuman() ):
                    utils.makeUnit(iSettler, iAztecs, tCapitals[iAztecs], 1)
                    utils.makeUnit(iScout, iAztecs, tCapitals[iAztecs], 1)
                if ( pAmerica.isHuman() ):
                    utils.makeUnit(iSettler, iAmerica, tCapitals[iAmerica], 1)
                    utils.makeUnit(iWarrior, iAmerica, tCapitals[iAmerica], 1)


        def assignTechs( self, iCiv ):
                #popup = Popup.PyPopup()
                #popup.setBodyString( 'assigning techs to civ #%d' %(iCiv))
                #popup.launch()            
                if (iCiv == iGreece):
                        teamGreece.setHasTech(con.iMining, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iWriting, True, iCiv, False, False)
                        #teamGreece.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        #teamGreece.setHasTech(con.iLiterature, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iHunting, True, iCiv, False, False)
                if (iCiv == iPersia):
                        teamPersia.setHasTech(con.iMining, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        #teamPersia.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iCarthage):
                        teamCarthage.setHasTech(con.iMining, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iSailing, True, iCiv, False, False)
                        #teamCarthage.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamCarthage.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iRome):
                        teamRome.setHasTech(con.iMining, True, iCiv, False, False)
                        teamRome.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamRome.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamRome.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamRome.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamRome.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamRome.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamRome.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamRome.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamRome.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamRome.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamRome.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamRome.setHasTech(con.iWriting, True, iCiv, False, False)
                        #teamRome.setHasTech(con.iCodeOfLaws, True, iCiv, False, False) founds Confucianism
                        teamRome.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamRome.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamRome.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                if (iCiv == iJapan):
                        teamJapan.setHasTech(con.iMining, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iMeditation, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iWriting, True, iCiv, False, False)
                if (iCiv == iArabia):
                        teamArabia.setHasTech(con.iMining, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iDivineRight, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iGuilds, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iVikings):
                        teamVikings.setHasTech(con.iMining, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamVikings.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                if (iCiv == iSpain):
                        teamSpain.setHasTech(con.iMining, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iFrance):
                        teamFrance.setHasTech(con.iMining, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMysticism, True, iCiv, False, False)                        
                        teamFrance.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iEngland):
                        teamEngland.setHasTech(con.iMining, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iGermany):
                        teamGermany.setHasTech(con.iMining, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iRussia):
                        teamRussia.setHasTech(con.iMining, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iMali):
                        teamMali.setHasTech(con.iMining, True, iCiv, False, False)
                        teamMali.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamMali.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamMali.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamMali.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamMali.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamMali.setHasTech(con.iDivineRight, True, iCiv, False, False)
                        teamMali.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamMali.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamMali.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamMali.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamMali.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamMali.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamMali.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamMali.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamMali.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamMali.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamMali.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iTurkey):
                        teamTurkey.setHasTech(con.iMining, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iDivineRight, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iGuilds, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iCalendar, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iEngineering, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamTurkey.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iInca):
                        teamInca.setHasTech(con.iMining, True, iCiv, False, False)
                        #teamInca.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamInca.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamInca.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamInca.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamInca.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamInca.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamInca.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamInca.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamInca.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamInca.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamInca.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamInca.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamInca.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamInca.setHasTech(con.iMathematics, True, iCiv, False, False)
                        #teamInca.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamInca.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamInca.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamInca.setHasTech(con.iArchery, True, iCiv, False, False)
                if (iCiv == iMongolia):
                        teamMongolia.setHasTech(con.iMining, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMeditation, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iGuilds, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)                      
                if (iCiv == iAztecs):
                        teamAztecs.setHasTech(con.iMining, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        #teamAztecs.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iCalendar, True, iCiv, False, False)
                        #teamAztecs.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iArchery, True, iCiv, False, False)
                if (iCiv == iAmerica):
                        for x in range(con.iLiberalism+1):
                                teamAmerica.setHasTech(x, True, iCiv, False, False)
                        for x in range(con.iFishing, con.iChemistry+1):
                                teamAmerica.setHasTech(x, True, iCiv, False, False)
                        for x in range(con.iHunting, con.iRifling+1):
                                teamAmerica.setHasTech(x, True, iCiv, False, False)
##                if (iCiv == iHolland):
##                        teamHolland.setHasTech(con.iMining, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iIronWorking, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iMetalCasting, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iMachinery, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iMysticism, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iPolytheism, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iMasonry, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iPriesthood, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iMonotheism, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iTheology, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iMonarchy, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iDivineRight, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iFishing, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iSailing, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iTheWheel, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iPottery, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iAgriculture, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iWriting, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iFeudalism, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iGuilds, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iAlphabet, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iMathematics, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iConstruction, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iEngineering, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iCurrency, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iHunting, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iArchery, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
##                        teamHolland.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
##                if (iCiv == iPortugal):
##                        teamPortugal.setHasTech(con.iMining, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iIronWorking, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iMetalCasting, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iMachinery, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iMysticism, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iPolytheism, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iMasonry, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iPriesthood, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iMonotheism, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iTheology, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iMonarchy, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iDivineRight, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iFishing, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iSailing, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iTheWheel, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iPottery, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iAgriculture, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iWriting, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iFeudalism, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iGuilds, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iAlphabet, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iMathematics, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iConstruction, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iEngineering, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iCurrency, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iHunting, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iArchery, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
##                        teamPortugal.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)




